'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（BiCGStab(2)法、温度解析はｽｶｲﾗｲﾝ法）
'定常解析のみ
'新手法･･･SUPG法を廃止し、各節点で速度勾配を保存
'新手法2･･･低粘度流体（水等）でPSPGの粘性項を既知扱いして右辺に移動
'          低粘度流体（水等）で安定化τpの追加係数を変更
'定常計算
'    速度勾配は今回、前回、前々回の３回分を使用し、緩和を組み込み
'    速度と圧力の緩和計算を分離
'    高粘度と低粘度を区分け
'    繰返し１回目は高粘度用で計算、２回目以降は高粘度・低粘度を区別
'
'    ＜対角優位の処理を組込み＞
'        １行毎の対角調整では、対角だけを変更する
'
'非定常計算･･･各時間間隔で計算１回
'    時間間隔の調整により発散防止
'    高粘度流体（樹脂等）、低粘度流体（水等）とも対応
Imports System.Drawing

Public Class FL3DCal3
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(224, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "３次元流れ解析計算の実行（反復法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(128, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(145, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(48, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(400, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'FL3DCal3
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "FL3DCal3"
        Me.Text = "FL3DCal3"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim Kinit As Integer        '非定常解析の区分（0:初回、1:次回以降）
    Dim NBvar As Integer        '速度・圧力非ｾﾞﾛ固定の変数の数
    Dim Neff As Integer         '縮小ﾏﾄﾘｯｸｽの変数の数
    Dim NumEff As Integer       'FEM1次行列のｲﾝﾃﾞｯｸｽ数
    Dim NumEffT As Integer      'FEM1次行列のｲﾝﾃﾞｯｸｽ数
    Dim Nvf As Integer          '流れ解析における1要素当りの変数の総数

    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置
    Dim RateMAmax As Single     '非定常の質量・対流比の最大値
    Dim RatePress0 As Single    '前回の入口圧力の修正比
    Dim RatePress1 As Single    '入口圧力の修正比
    Dim Stempold As Single      '前回の温度変化量の最大値
    Dim Svelold As Single       '前回の速度変化量の最大値
    Dim TauPS As Single         'PSPG係数
    Dim TimeStd As Single       '非定常の初期基準時間
    Dim VelAve0 As Single       '前回の入口の平均流速
    Dim VelAve1 As Single       '入口の平均流速

    Dim IdiagT() As Integer     '温度のFEM行列対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim Jcolnum() As Integer    '保存配列要素について、元のFEM行列の列番号
    Dim KBfix() As Integer      '速度･圧力非ｾﾞﾛ固定の変数番号
    Dim KBkind() As Integer     '固定変数の区分（0:速度、1:圧力）
    Dim KRelax() As Integer     '計算変数の緩和計算有無
    Dim KrowDpos() As Integer   '保存配列における各行対角要素のｲﾝﾃﾞｯｸｽ番号
    Dim KrowDposT() As Integer  '保存配列における各行対角要素のｲﾝﾃﾞｯｸｽ番号
    Dim Krowpos() As Integer    '保存配列における各行第1列のｲﾝﾃﾞｯｸｽ番号
    Dim KrowposT() As Integer   '保存配列における各行第1列のｲﾝﾃﾞｯｸｽ番号
    Dim KVarMax(8) As Integer   '最大値の節点番号
    Dim NPrefT() As Integer     '温度計算における節点温度の対応番号
    Dim NTrest() As Integer     '温度固定の有無(0:固定なし、1:固定有り)
    Dim NumDiagT() As Integer   '温度のFEM行列対角毎のﾊｰﾌｲﾝﾃﾞｯｸｽ数

    Dim Bkx(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのKx
    Dim Bky(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのKy
    Dim Bkz(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのKz
    Dim DUE(20), DVE(20), DWE(20) As Double   '要素節点の速度U、V、Wの増分
    Dim Ek(80, 80) As Double    '要素計算の２次配列
    Dim Exx(20, 20) As Double   '非線形項Exx(i,j)
    Dim Exy(20, 20) As Double   '非線形項Exy(i,j)
    Dim Exz(20, 20) As Double   '非線形項Exz(i,j)
    Dim Eyx(20, 20) As Double   '非線形項Eyx(i,j)
    Dim Eyy(20, 20) As Double   '非線形項Eyy(i,j)
    Dim Eyz(20, 20) As Double   '非線形項Eyz(i,j)
    Dim Ezx(20, 20) As Double   '非線形項Ezx(i,j)
    Dim Ezy(20, 20) As Double   '非線形項Ezy(i,j)
    Dim Ezz(20, 20) As Double   '非線形項Ezz(i,j)
    Dim ForceB(20, 4) As Double '物体力
    Dim HElem() As Single       '要素長
    Dim Hp(20, 20) As Double    'PSPGの圧力項
    Dim Hsx(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのHsx
    Dim Hsy(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのHsy
    Dim Hsz(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのHsz
    Dim Hx(20, 20) As Double    '要素ﾏﾄﾘｯｸｽのHx
    Dim Hy(20, 20) As Double    '要素ﾏﾄﾘｯｸｽのHy
    Dim Hz(20, 20) As Double    '要素ﾏﾄﾘｯｸｽのHz
    Dim PDE(20, 9) As Double    '要素節点での速度の偏微分
    Dim RM(20) As Double        '非定常の節点質量
    Dim TEb(20) As Double       '要素節点の前回温度
    Dim TempFix() As Double     '固定温度
    Dim Tf() As Double          'FEMの右辺項
    Dim Tff0() As Double        '時間0の速度・圧力
    Dim Tft() As Double         '温度FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tftx() As Double        '前時間ｽﾃｯﾌﾟの温度
    Dim TimeVMax(8) As Single   '各変数の最大時の時間
    Dim Tk() As Double          'FEM行列の1次元保存配列
    Dim Tk2() As Double         '不完全LU行列の1次元保存配列
    Dim Told(), Toldx() As Double '温度計算の前２回分の解
    Dim VarMax(8) As Single     '各変数の最大値
    Dim VBfix() As Double       '速度・圧力の非ｾﾞﾛ固定値
    Dim Vold(), Voldx() As Double '流れ計算の前２回分の解

    Private Sub BandWidth(ByRef mbh As Integer, ByRef mbht As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算
        'mbh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbht･･･温度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, ib, ibx, ie, ii, j, jb, jbx, jj, k, k1, k2, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        mbh = 0 : mbht = 0
        For ie = 1 To Nelem
            ii = 0
            jj = 0
            For i = 1 To nmax
                ib = NNelem(ie, i)
                ibx = Kcomp(ib)
                k1 = Ndim * (Kcomp(ibx) - 1)
                For j = 1 To Ndim
                    k1 = k1 + 1
                    k2 = Lcomp(k1)
                    If k2 > 0 Then
                        If ii = 0 Then
                            ii = k2
                            jj = k2
                        ElseIf k2 < ii Then
                            ii = k2
                        ElseIf k2 > jj Then
                            jj = k2
                        End If
                    End If
                Next j
                If i < nmax Then
                    For j = i + 1 To nmax
                        jb = NNelem(ie, j)
                        jbx = Kcomp(jb)
                        k = Math.Abs(ibx - jbx)
                        If k > mbht Then
                            mbht = k
                        End If
                    Next j
                End If
            Next i
            k = jj - ii
            If k > mbh Then
                mbh = k
            End If
        Next ie
        mbh = mbh + 1
        mbht = mbht + 1

    End Sub

    Private Sub BandWidthx(ByRef mbh As Integer, ByRef mbht As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算
        'mbh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbht･･･温度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, ib, ie, ii, iiT, j, jj, jjT, k, k1, k2, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        mbh = 0 : mbht = 0
        For ie = 1 To Nelem
            ii = 0
            jj = 0
            iiT = 0
            jjT = 0
            For i = 1 To nmax
                ib = NNelem(ie, i)
                k1 = Ndim * (ib - 1)
                For j = 1 To Ndim
                    k1 = k1 + 1
                    k2 = Lcomp(k1)
                    If k2 > 0 Then
                        If ii = 0 Then
                            ii = k2
                            jj = k2
                        ElseIf k2 < ii Then
                            ii = k2
                        ElseIf k2 > jj Then
                            jj = k2
                        End If
                    End If
                Next j
                If iiT = 0 Then
                    iiT = ib
                    jjT = ib
                ElseIf ib < iiT Then
                    iiT = ib
                ElseIf ib > jjT Then
                    jjT = ib
                End If
            Next i
            k = jj - ii
            If k > mbh Then
                mbh = k
            End If
            k = jjT - iiT
            If k > mbht Then
                mbht = k
            End If
        Next ie
        mbh = mbh + 1
        mbht = mbht + 1

    End Sub

    Private Sub BCGStabL(ByVal nx As Integer, ByVal numef As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽ用BCGStabL法ｿﾙﾊﾞｰ計算
        'nx･･･変数の個数
        'numef･･･配列の保存要素数
        Dim aa$, timn$
        Dim i, ib, ic, icount, ik, j, j1, j2, jj As Integer
        Dim k, k1, k2, kdiv, kk, nk As Integer
        Dim dn, riter As Single
        Dim alp, b1, b2, beta, cnorm, eps, epsA, epsA2 As Double
        Dim ganma1, ganma2, ganmad1, ganmad2, ganmadd As Double
        Dim omega, rou0, rou1, sigma1, sigma2, tau As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Application.DoEvents()
        timn$ = ""

        'ｽｹｰﾘﾝｸﾞ
        Dim Sd(nx) As Double
        For i = 1 To nx
            ib = KrowDpos(i)
            b1 = Tk(ib)
            Sd(i) = 1 / Math.Sqrt(b1)
            Tk(ib) = 1
        Next i
        For i = 1 To nx
            j1 = Krowpos(i)
            j2 = Krowpos(i + 1) - 1
            For j = j1 To j2
                b1 = Tk(j)
                If j <> KrowDpos(i) And b1 <> 0 Then
                    Tk(j) = b1 * Sd(i) * Sd(Jcolnum(j))
                End If
            Next j
            Tf(i) = Tf(i) * Sd(i)
        Next i

        For i = 1 To numef
            Tk2(i) = Tk(i)
        Next i

        '不完全ｺﾚｽｷｰ分解
        dn = nx / 10.0 - 0.001
        riter = dn
        kdiv = 0
        Application.DoEvents()
        icount = 0
        For i = 1 To nx
            For j = Krowpos(i) To KrowDpos(i)
                b1 = Tk(j)
                If b1 <> 0 Then
                    j1 = Jcolnum(j)
                    b2 = 0
                    For k = Krowpos(i) To KrowDpos(i) - 1
                        jj = Jcolnum(k)
                        If jj < j1 Then
                            k1 = Krowpos(jj)
                            k2 = Krowpos(jj + 1) - 1
                            For kk = k1 To k2
                                j2 = Jcolnum(kk)
                                If j1 = j2 Then
                                    b2 = b2 + Tk2(k) * Tk2(kk)
                                    Exit For
                                ElseIf j2 > j1 Then
                                    Exit For
                                End If
                            Next kk
                        End If
                    Next k
                    Tk2(j) = b1 - b2
                End If
            Next j
            For j = KrowDpos(i) + 1 To Krowpos(i + 1) - 1
                b1 = Tk(j)
                If b1 <> 0 Then
                    j1 = Jcolnum(j)
                    b2 = 0
                    For k = Krowpos(i) To KrowDpos(i) - 1
                        jj = Jcolnum(k)
                        k1 = Krowpos(jj)
                        k2 = Krowpos(jj + 1) - 1
                        For kk = k1 To k2
                            j2 = Jcolnum(kk)
                            If j1 = j2 Then
                                b2 = b2 + Tk2(k) * Tk2(kk)
                                Exit For
                            ElseIf j2 > j1 Then
                                Exit For
                            End If
                        Next kk
                    Next k
                    Tk2(j) = (b1 - b2) / Tk2(KrowDpos(i))
                End If
            Next j
            riter = riter - 1
            If riter <= 0 Then
                aa$ = "不完全ｺﾚｽｷｰ分解  i=" + Str$(i) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                kdiv = kdiv + 1
                riter = dn
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next i

        '本計算
        nk = nx / 3 '最大繰返し数
        eps = 0.00000001 '収束基準比率
        Dim apvec(nx), rvec0(nx), rvec1(nx), rvec2(nx) As Double
        Dim uvec0(nx), uvec1(nx), uvec2(nx) As Double

        cnorm = 0
        For i = 1 To nx
            cnorm = cnorm + Tf(i) * Tf(i)
        Next i
        cnorm = Math.Sqrt(cnorm)
        epsA = eps * cnorm
        epsA2 = 100 * epsA
        Call PreVecCalc2(nx, Tf, rvec0) 'InvC･vecの計算2
        For i = 1 To nx
            Tf(i) = 0
        Next i

        rou0 = 1 : alp = 1 : omega = 1
        ic = 0
        Application.DoEvents()
        For ik = 1 To nk
            aa$ = "BCGStabL  ik=" + Str$(ik) + "  "
            If Mstat > 0 Then
                aa$ = "時間" + Str(TimeNew) + "   " + aa$
            End If
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            rou0 = -omega * rou0
            For k = 0 To 1  'BCG計算
                b1 = 0
                For i = 1 To nx
                    If k = 0 Then
                        b2 = rvec0(i)
                    Else
                        b2 = rvec1(i)
                    End If
                    b1 = b1 + b2 * rvec0(i)
                Next i
                rou1 = b1
                beta = alp * rou1 / rou0
                rou0 = rou1
                For i = 1 To nx
                    uvec0(i) = rvec0(i) - beta * uvec0(i)
                    If k = 1 Then
                        uvec1(i) = rvec1(i) - beta * uvec1(i)
                    End If
                Next i
                For i = 1 To nx
                    b1 = 0
                    For j = Krowpos(i) To Krowpos(i + 1) - 1
                        jj = Jcolnum(j)
                        If k = 0 Then
                            b2 = uvec0(jj)
                        Else
                            b2 = uvec1(jj)
                        End If
                        b1 = b1 + Tk(j) * b2
                    Next j
                    apvec(i) = b1
                Next i
                If k = 0 Then
                    Call PreVecCalc2(nx, apvec, uvec1) 'InvC･vecの計算2
                Else
                    Call PreVecCalc2(nx, apvec, uvec2) 'InvC･vecの計算2
                End If
                Application.DoEvents()
                b1 = 0
                For i = 1 To nx
                    If k = 0 Then
                        b2 = uvec1(i)
                    Else
                        b2 = uvec2(i)
                    End If
                    b1 = b1 + b2 * rvec0(i)
                Next i
                alp = rou0 / b1
                For i = 1 To nx
                    rvec0(i) = rvec0(i) - alp * uvec1(i)
                    If k = 1 Then
                        rvec1(i) = rvec1(i) - alp * uvec2(i)
                    End If
                Next i
                For i = 1 To nx
                    b1 = 0
                    For j = Krowpos(i) To Krowpos(i + 1) - 1
                        jj = Jcolnum(j)
                        If k = 0 Then
                            b2 = rvec0(jj)
                        Else
                            b2 = rvec1(jj)
                        End If
                        b1 = b1 + Tk(j) * b2
                    Next j
                    apvec(i) = b1
                Next i
                If k = 0 Then
                    Call PreVecCalc2(nx, apvec, rvec1) 'InvC･vecの計算2
                Else
                    Call PreVecCalc2(nx, apvec, rvec2) 'InvC･vecの計算2
                End If
                For i = 1 To nx
                    Tf(i) = Tf(i) + alp * uvec0(i)
                Next i
            Next k

            For k = 1 To 2  'MR計算
                If k = 2 Then
                    b1 = 0
                    For i = 1 To nx
                        b1 = b1 + rvec2(i) * rvec1(i)
                    Next i
                    tau = b1 / sigma1
                    For i = 1 To nx
                        rvec2(i) = rvec2(i) - tau * rvec1(i)
                    Next i
                End If
                b1 = 0
                For i = 1 To nx
                    If k = 1 Then
                        b2 = rvec1(i)
                    Else
                        b2 = rvec2(i)
                    End If
                    b1 = b1 + b2 * b2
                Next i
                If k = 1 Then
                    sigma1 = b1
                Else
                    sigma2 = b1
                End If
                b1 = 0
                For i = 1 To nx
                    If k = 1 Then
                        b2 = rvec1(i)
                    Else
                        b2 = rvec2(i)
                    End If
                    b1 = b1 + rvec0(i) * b2
                Next i
                If k = 1 Then
                    ganmad1 = b1 / sigma1
                Else
                    ganmad2 = b1 / sigma2
                End If
            Next k
            ganma2 = ganmad2
            omega = ganma2
            ganma1 = ganmad1 - tau * ganma2
            ganmadd = ganma2
            For i = 1 To nx
                Tf(i) = Tf(i) + ganma1 * rvec0(i)
                rvec0(i) = rvec0(i) - ganmad2 * rvec2(i)
                uvec0(i) = uvec0(i) - ganma2 * uvec2(i)
            Next i
            b1 = 0
            For i = 1 To nx
                uvec0(i) = uvec0(i) - ganma1 * uvec1(i)
                Tf(i) = Tf(i) + ganmadd * rvec1(i)
                rvec0(i) = rvec0(i) - ganmad1 * rvec1(i)
                b1 = b1 + rvec0(i) * rvec0(i)
            Next i
            b1 = Math.Sqrt(b1)
            If (ik > 5 And b1 <= epsA) Or (ik > 100 And b1 <= epsA2) Then
                ic = 1
                Exit For
            End If
        Next ik
        If ic = 0 Then
            aa$ = "ソルバー計算が収束しません！"
            MsgBox(aa$, 0, "計算エラー")
            End
        End If

        'ｽｹｰﾘﾝｸﾞの戻し
        For i = 1 To nx
            Tf(i) = Tf(i) * Sd(i)
        Next i

        gr.Dispose()

    End Sub

    Private Sub CalcParam(ByVal ie As Integer, ByVal kindvisc As Integer)
        '安定化ﾊﾟﾗﾒｰﾀｰの計算
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        Dim numg As Integer
        Dim b0, b1, b2, b3, bf, ce, dj, et, gd, he As Double
        Dim s, t, temp, u As Double

        numg = 0
        If KindElem = 0 Then
            s = 0 : t = 0 : u = 0
            Call ShapeFunc(1, s, t, u)    '形状関数の計算
        End If
        Call JacobElem(ie, 1, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        et = Rmyu
        If kindvisc > 0 And Kvisc > 0 Then
            Call ShearRate(bf, dj, gd) '剪断速度の計算
            If KindTherm = 0 Then
                temp = Tempi
            Else
                temp = TG(numg)
            End If
            Call ViscEqua(et, gd, temp)     '粘度式計算
        End If
        ce = Math.Sqrt(UG(numg) ^ 2 + VG(numg) ^ 2 + WG(numg) ^ 2)
        If Mstat = 0 Then
            b0 = 0
        Else
            b0 = 2 / Dtime
        End If
        he = HElem(ie)
        b1 = 2 * ce / he
        b2 = 4 * (et / Rou) / (he * he)
        b3 = 1 / Math.Sqrt(b0 * b0 + b1 * b1 + b2 * b2)
        TauPS = Cratio * b3

    End Sub

    Private Sub CalcPrep(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算準備
        'ie･･･要素番号
        Dim i, i2, ii, j, jj, k, kb, kk, m, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        j = 0
        For i = 1 To nmax
            i2 = NNelem(ie, i)
            k = Kcomp(i2)
            XE(i) = Xdata(i2)
            YE(i) = Ydata(i2)
            ZE(i) = Zdata(i2)
            NPrefT(i) = k
            TE(i) = Tft(k)
            kk = Ndim * (k - 1) + 1
            For m = 0 To 2
                kb = Lcomp(kk + m)
                Select Case m
                    Case 0
                        If kb = 0 Then
                            UE(i) = 0
                        Else
                            UE(i) = Tff(kb)
                        End If
                    Case 1
                        If kb = 0 Then
                            VE(i) = 0
                        Else
                            VE(i) = Tff(kb)
                        End If
                    Case 2
                        If kb = 0 Then
                            WE(i) = 0
                        Else
                            WE(i) = Tff(kb)
                        End If
                End Select
            Next m

            For ii = 0 To 3
                j = j + 1
                jj = kk + ii
                NPrefer(j) = Lcomp(jj)
            Next ii

            For m = 1 To 9
                PDE(i, m) = PDVel(k, m)
            Next m

        Next i

    End Sub

    Private Sub CalcPrepT(ByVal ie As Integer)
        '非定常の要素ﾏﾄﾘｯｸｽの計算準備
        'ie･･･要素番号
        Dim i, i2, j, k, kb, kk, m, nmax As Integer
        Dim b1, b2 As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        j = 0
        For i = 1 To nmax
            i2 = NNelem(ie, i)
            k = Kcomp(i2)
            XE(i) = Xdata(i2)
            YE(i) = Ydata(i2)
            ZE(i) = Zdata(i2)
            NPrefT(i) = k
            TE(i) = 0.5 * (Tft(k) + Tftx(k))
            TEb(i) = Tftx(k)
            kk = Ndim * (k - 1) + 1
            For m = 0 To 3
                kb = Lcomp(kk + m)
                j = j + 1
                NPrefer(j) = kb
                b1 = 0.5 * (Tff(kb) + Tffx(kb))
                b2 = b1 - Vold(kb)
                Select Case m
                    Case 0
                        If kb = 0 Then
                            UE(i) = 0
                            UEb(i) = 0
                            DUE(i) = 0
                        Else
                            UE(i) = b1
                            UEb(i) = Tffx(kb)
                            DUE(i) = b2
                        End If
                    Case 1
                        If kb = 0 Then
                            VE(i) = 0
                            VEb(i) = 0
                            DVE(i) = 0
                        Else
                            VE(i) = b1
                            VEb(i) = Tffx(kb)
                            DVE(i) = b2
                        End If
                    Case 2
                        If kb = 0 Then
                            WE(i) = 0
                            WEb(i) = 0
                            DWE(i) = 0
                        Else
                            WE(i) = b1
                            WEb(i) = Tffx(kb)
                            DWE(i) = b2
                        End If
                End Select
            Next m

            For m = 1 To 9
                PDE(i, m) = PDVel(k, m)
            Next m

        Next i

    End Sub

    Private Sub CoefMatrix(ByVal ie As Integer, ByVal kindvisc As Integer,
        ByVal mtg As Integer)
        '係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        'mtg･･･対流項の有無（0:なし、1:有り)
        Dim i, i1, i2, i3, i4, ig, j, j1, j2, j3, j4, jg As Integer
        Dim k, kb, kg, kk, numg As Integer
        Dim b1, b2, b3, b4, b5, bf, bsum, dj, dv As Double
        Dim et, g1, g2, g3, gd, s, t, temp, u As Double
        Dim dxvel(3), dyvel(3), dzvel(3), fk(20) As Double
        Dim buf(20) As Double

        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    u = PosGaus(kg)
                    numg = numg + 1
                    Call ShapeFunc(1, s, t, u)    '形状関数の計算
                    Call JacobElem(ie, 1, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    Call ShapeFunc2(s, t, u)   '形状関数の2階の偏微分計算

                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)

                    et = Rmyu
                    If kindvisc > 0 And Kvisc > 0 Then
                        If Kvisc < 4 Then
                            Call ShearRate(bf, dj, gd) '剪断速度の計算
                        End If
                        If KindTherm = 0 Then
                            temp = Tempi
                        Else
                            temp = TG(numg)
                        End If
                        Call ViscEqua(et, gd, temp)     '粘度式計算
                    End If

                    For k = 1 To 3
                        dxvel(k) = 0
                        dyvel(k) = 0
                        dzvel(k) = 0
                    Next k
                    For i = 1 To 20
                        dxvel(1) = dxvel(1) + Shape(i) * PDE(i, 1)
                        dxvel(2) = dxvel(2) + Shape(i) * PDE(i, 4)
                        dxvel(3) = dxvel(3) + Shape(i) * PDE(i, 7)
                        dyvel(1) = dyvel(1) + Shape(i) * PDE(i, 2)
                        dyvel(2) = dyvel(2) + Shape(i) * PDE(i, 5)
                        dyvel(3) = dyvel(3) + Shape(i) * PDE(i, 8)
                        dzvel(1) = dzvel(1) + Shape(i) * PDE(i, 3)
                        dzvel(2) = dzvel(2) + Shape(i) * PDE(i, 6)
                        dzvel(3) = dzvel(3) + Shape(i) * PDE(i, 9)
                    Next i

                    For j = 1 To 20
                        fk(j) = 0
                    Next j
                    For j = 1 To 20
                        b1 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    b2 = Dss(j)
                                Case 2
                                    b2 = Dtt(j)
                                Case 3
                                    b2 = Duu(j)
                            End Select
                            b1 = b1 + b2 * (RinvJT(1, k) ^ 2 + RinvJT(2, k) ^ 2 + RinvJT(3, k) ^ 2)
                        Next k
                        b3 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    kb = 2
                                    b2 = 2 * Dst(j)
                                Case 2
                                    kb = 3
                                    b2 = 2 * Dtu(j)
                                Case 3
                                    kb = 1
                                    b2 = 2 * Dus(j)
                            End Select
                            b4 = 0
                            For kk = 1 To 3
                                b4 = b4 + RinvJT(kk, k) * RinvJT(kk, kb)
                            Next kk
                            b3 = b3 + b2 * b4
                        Next k
                        fk(j) = b1 + b3
                    Next j

                    For i = 1 To 20
                        g1 = Dx(i) * dxvel(1) + Dy(i) * dxvel(2) + Dz(i) * dxvel(3)
                        g2 = Dx(i) * dyvel(1) + Dy(i) * dyvel(2) + Dz(i) * dyvel(3)
                        g3 = Dx(i) * dzvel(1) + Dy(i) * dzvel(2) + Dz(i) * dzvel(3)
                        For j = 1 To 20
                            b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            b2 = et * b1 * dv
                            Bkx(i, j) = Bkx(i, j) + b2
                            Bky(i, j) = Bky(i, j) + b2
                            Bkz(i, j) = Bkz(i, j) + b2
                            b4 = Shape(i) * dv
                            Hx(i, j) = Hx(i, j) + b4 * Dx(j)
                            Hy(i, j) = Hy(i, j) + b4 * Dy(j)
                            Hz(i, j) = Hz(i, j) + b4 * Dz(j)

                            'P行
                            If KindRelax = 0 Then
                                Hsx(i, j) = Hsx(i, j) + b4 * Dx(j)
                                Hsy(i, j) = Hsy(i, j) + b4 * Dy(j)
                                Hsz(i, j) = Hsz(i, j) + b4 * Dz(j)
                            Else    '低粘度流体向き
                                b1 = b4 * Dx(j) * UE(j)
                                b2 = b4 * Dy(j) * VE(j)
                                b3 = b4 * Dz(j) * WE(j)
                                buf(i) = buf(i) + b1 + b2 + b3
                            End If

                            bsum = fk(j)
                            b4 = -TauPS * et * bsum * dv / Rou
                            If KindRelax = 0 Then
                                Hsx(i, j) = Hsx(i, j) + Dx(i) * b4
                                Hsy(i, j) = Hsy(i, j) + Dy(i) * b4
                                Hsz(i, j) = Hsz(i, j) + Dz(i) * b4
                            Else    '低粘度流体向き
                                b1 = b4 * Dx(i) * UE(j)
                                b2 = b4 * Dy(i) * VE(j)
                                b3 = b4 * Dz(i) * WE(j)
                                buf(i) = buf(i) + b1 + b2 + b3
                            End If

                            b4 = TauPS * dv / Rou
                            b5 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            Hp(i, j) = Hp(i, j) + b4 * b5

                            If mtg > 0 Then
                                b1 = Rou * Shape(i) * Shape(j) * dv
                                Exx(i, j) = Exx(i, j) + b1 * dxvel(1)
                                Exy(i, j) = Exy(i, j) + b1 * dyvel(1)
                                Exz(i, j) = Exz(i, j) + b1 * dzvel(1)
                                Eyx(i, j) = Eyx(i, j) + b1 * dxvel(2)
                                Eyy(i, j) = Eyy(i, j) + b1 * dyvel(2)
                                Eyz(i, j) = Eyz(i, j) + b1 * dzvel(2)
                                Ezx(i, j) = Ezx(i, j) + b1 * dxvel(3)
                                Ezy(i, j) = Ezy(i, j) + b1 * dyvel(3)
                                Ezz(i, j) = Ezz(i, j) + b1 * dzvel(3)

                                'P行
                                b5 = TauPS * Shape(j) * dv
                                b1 = b5 * g1 * UE(j)
                                b2 = b5 * g2 * VE(j)
                                b3 = b5 * g3 * WE(j)
                                buf(i) = buf(i) + b1 + b2 + b3

                            End If
                        Next j

                        If KBodyForce > 0 Then
                            For k = 1 To 3
                                If Accel(k) <> 0 Then
                                    b1 = Rou * Accel(k) * dv
                                    ForceB(i, k) = ForceB(i, k) + Shape(i) * b1
                                    b3 = TauPS * Accel(k) * dv
                                    Select Case k
                                        Case 1
                                            b4 = Dx(i)
                                        Case 2
                                            b4 = Dy(i)
                                        Case 3
                                            b4 = Dz(i)
                                    End Select
                                    ForceB(i, 4) = ForceB(i, 4) + b4 * b3
                                End If
                            Next k
                        End If
                    Next i
                Next kg
            Next jg
        Next ig

        For i = 1 To 20
            i1 = 4 * i - 3
            i2 = i1 + 1
            i3 = i1 + 2
            i4 = i1 + 3
            For j = 1 To 20
                j1 = 4 * j - 3
                j2 = j1 + 1
                j3 = j1 + 2
                j4 = j1 + 3
                Ek(i1, j1) = Bkx(i, j)
                Ek(i2, j2) = Bky(i, j)
                Ek(i3, j3) = Bkz(i, j)

                Ek(i1, j4) = Hx(i, j)
                Ek(i2, j4) = Hy(i, j)
                Ek(i3, j4) = Hz(i, j)
                Ek(i4, j1) = Hsx(i, j)
                Ek(i4, j2) = Hsy(i, j)
                Ek(i4, j3) = Hsz(i, j)
                Ek(i4, j4) = Hp(i, j)
            Next j
        Next i

        For i = 1 To 20
            b1 = 0
            b2 = 0
            b3 = 0
            For j = 1 To 20
                b1 = b1 + Exx(i, j) * UE(j) + Exy(i, j) * VE(j) + Exz(i, j) * WE(j)
                b2 = b2 + Eyx(i, j) * UE(j) + Eyy(i, j) * VE(j) + Eyz(i, j) * WE(j)
                b3 = b3 + Ezx(i, j) * UE(j) + Ezy(i, j) * VE(j) + Ezz(i, j) * WE(j)
            Next j
            ForceB(i, 1) = ForceB(i, 1) - b1
            ForceB(i, 2) = ForceB(i, 2) - b2
            ForceB(i, 3) = ForceB(i, 3) - b3
            ForceB(i, 4) = ForceB(i, 4) - buf(i)
        Next i

    End Sub

    Private Sub CoefMatrixT(ByVal ie As Integer, ByVal kindvisc As Integer, _
        ByVal mtg As Integer)
        '非定常の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        'mtg･･･対流項の有無（0:なし、1:有り)
        Dim i, i1, i2, i3, i4, ig, j, j1, j2, j3, j4, jg As Integer
        Dim k, kb, kg, kk, numg As Integer
        Dim b1, b2, b3, b4, b5, bf, dj, dv As Double
        Dim et, g1, g2, g3, gd, s, t, temp, u As Double
        Dim dxvel(3), dyvel(3), dzvel(3), fk(20) As Double

        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    u = PosGaus(kg)
                    numg = numg + 1
                    Call ShapeFunc(1, s, t, u)    '形状関数の計算
                    Call JacobElem(ie, 1, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    Call ShapeFunc2(s, t, u)   '形状関数の2階の偏微分計算

                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)

                    et = Rmyu
                    If kindvisc > 0 And Kvisc > 0 Then
                        If Kvisc < 4 Then
                            Call ShearRate(bf, dj, gd) '剪断速度の計算
                        End If
                        If KindTherm = 0 Then
                            temp = Tempi
                        Else
                            temp = TG(numg)
                        End If
                        Call ViscEqua(et, gd, temp)     '粘度式計算
                    End If

                    For k = 1 To 3
                        dxvel(k) = 0
                        dyvel(k) = 0
                        dzvel(k) = 0
                    Next k
                    For i = 1 To 20
                        dxvel(1) = dxvel(1) + Shape(i) * PDE(i, 1)
                        dxvel(2) = dxvel(2) + Shape(i) * PDE(i, 4)
                        dxvel(3) = dxvel(3) + Shape(i) * PDE(i, 7)
                        dyvel(1) = dyvel(1) + Shape(i) * PDE(i, 2)
                        dyvel(2) = dyvel(2) + Shape(i) * PDE(i, 5)
                        dyvel(3) = dyvel(3) + Shape(i) * PDE(i, 8)
                        dzvel(1) = dzvel(1) + Shape(i) * PDE(i, 3)
                        dzvel(2) = dzvel(2) + Shape(i) * PDE(i, 6)
                        dzvel(3) = dzvel(3) + Shape(i) * PDE(i, 9)
                    Next i

                    For j = 1 To 20
                        fk(j) = 0
                    Next j
                    For j = 1 To 20
                        b1 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    b2 = Dss(j)
                                Case 2
                                    b2 = Dtt(j)
                                Case 3
                                    b2 = Duu(j)
                            End Select
                            b1 = b1 + b2 * (RinvJT(1, k) ^ 2 + RinvJT(2, k) ^ 2 + RinvJT(3, k) ^ 2)
                        Next k
                        b3 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    kb = 2
                                    b2 = 2 * Dst(j)
                                Case 2
                                    kb = 3
                                    b2 = 2 * Dtu(j)
                                Case 3
                                    kb = 1
                                    b2 = 2 * Dus(j)
                            End Select
                            b4 = 0
                            For kk = 1 To 3
                                b4 = b4 + RinvJT(kk, k) * RinvJT(kk, kb)
                            Next kk
                            b3 = b3 + b2 * b4
                        Next k
                        fk(j) = b1 + b3
                    Next j

                    For i = 1 To 20
                        g1 = Dx(i) * dxvel(1) + Dy(i) * dxvel(2) + Dz(i) * dxvel(3)
                        g2 = Dx(i) * dyvel(1) + Dy(i) * dyvel(2) + Dz(i) * dyvel(3)
                        g3 = Dx(i) * dzvel(1) + Dy(i) * dzvel(2) + Dz(i) * dzvel(3)
                        For j = 1 To 20
                            b1 = Rou * Shape(i) * Shape(j) * dv
                            RM(i) = RM(i) + b1

                            b1 = Rou * Shape(i) * Shape(j) * dv / Dtime
                            Bkx(i, j) = Bkx(i, j) + b1
                            Bky(i, j) = Bky(i, j) + b1
                            Bkz(i, j) = Bkz(i, j) + b1
                            ForceB(i, 1) = ForceB(i, 1) + b1 * UEb(j)
                            ForceB(i, 2) = ForceB(i, 2) + b1 * VEb(j)
                            ForceB(i, 3) = ForceB(i, 3) + b1 * WEb(j)

                            b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            b2 = 0.5 * et * b1 * dv
                            Bkx(i, j) = Bkx(i, j) + b2
                            Bky(i, j) = Bky(i, j) + b2
                            Bkz(i, j) = Bkz(i, j) + b2
                            ForceB(i, 1) = ForceB(i, 1) - b2 * UEb(j)
                            ForceB(i, 2) = ForceB(i, 2) - b2 * VEb(j)
                            ForceB(i, 3) = ForceB(i, 3) - b2 * WEb(j)

                            b3 = Shape(i) * dv
                            Hx(i, j) = Hx(i, j) + b3 * Dx(j)
                            Hy(i, j) = Hy(i, j) + b3 * Dy(j)
                            Hz(i, j) = Hz(i, j) + b3 * Dz(j)

                            'P行
                            b4 = Shape(i) * dv
                            Hsx(i, j) = Hsx(i, j) + b4 * Dx(j)
                            Hsy(i, j) = Hsy(i, j) + b4 * Dy(j)
                            Hsz(i, j) = Hsz(i, j) + b4 * Dz(j)

                            b4 = TauPS * Shape(j) * dv / Dtime
                            b1 = b4 * (Dx(i) * DUE(j) + Dy(i) * DVE(j) + Dz(i) * DWE(j))
                            ForceB(i, 4) = ForceB(i, 4) - b1

                            b4 = 0.5 * TauPS * et * fk(j) * dv / Rou
                            Hsx(i, j) = Hsx(i, j) - Dx(i) * b4
                            Hsy(i, j) = Hsy(i, j) - Dy(i) * b4
                            Hsz(i, j) = Hsz(i, j) - Dz(i) * b4
                            b1 = b4 * (Dx(i) * UEb(j) + Dy(i) * VEb(j) + Dz(i) * WEb(j))
                            ForceB(i, 4) = ForceB(i, 4) + b1

                            b4 = TauPS * dv / Rou
                            b5 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            Hp(i, j) = Hp(i, j) + b4 * b5

                            If mtg > 0 Then
                                b1 = 0.5 * Rou * Shape(i) * Shape(j) * dv
                                Exx(i, j) = Exx(i, j) + b1 * dxvel(1)
                                Exy(i, j) = Exy(i, j) + b1 * dyvel(1)
                                Exz(i, j) = Exz(i, j) + b1 * dzvel(1)
                                b4 = b1 * (dxvel(1) * UEb(j) + dyvel(1) * VEb(j) + dzvel(1) * WEb(j))
                                ForceB(i, 1) = ForceB(i, 1) - b4
                                Eyx(i, j) = Eyx(i, j) + b1 * dxvel(2)
                                Eyy(i, j) = Eyy(i, j) + b1 * dyvel(2)
                                Eyz(i, j) = Eyz(i, j) + b1 * dzvel(2)
                                b4 = b1 * (dxvel(2) * UEb(j) + dyvel(2) * VEb(j) + dzvel(2) * WEb(j))
                                ForceB(i, 2) = ForceB(i, 2) - b4
                                Ezx(i, j) = Ezx(i, j) + b1 * dxvel(3)
                                Ezy(i, j) = Ezy(i, j) + b1 * dyvel(3)
                                Ezz(i, j) = Ezz(i, j) + b1 * dzvel(3)
                                b4 = b1 * (dxvel(3) * UEb(j) + dyvel(3) * VEb(j) + dzvel(3) * WEb(j))
                                ForceB(i, 3) = ForceB(i, 3) - b4

                                'P行
                                b5 = 0.5 * TauPS * Shape(j) * dv
                                b1 = b5 * g1
                                b2 = b5 * g2
                                b3 = b5 * g3
                                Hsx(i, j) = Hsx(i, j) + b1
                                Hsy(i, j) = Hsy(i, j) + b2
                                Hsz(i, j) = Hsz(i, j) + b3
                                ForceB(i, 4) = ForceB(i, 4) - b1 * UEb(j) - b2 * VEb(j) - b3 * WEb(j)
                            End If
                        Next j

                        If KBodyForce > 0 Then
                            For k = 1 To 3
                                If Accel(k) <> 0 Then
                                    b1 = Rou * Accel(k) * dv
                                    ForceB(i, k) = ForceB(i, k) + Shape(i) * b1
                                    b3 = TauPS * Accel(k) * dv
                                    Select Case k
                                        Case 1
                                            b4 = Dx(i)
                                        Case 2
                                            b4 = Dy(i)
                                        Case 3
                                            b4 = Dz(i)
                                    End Select
                                    ForceB(i, 4) = ForceB(i, 4) + b4 * b3
                                End If
                            Next k
                        End If
                    Next i
                Next kg
            Next jg
        Next ig

        For i = 1 To 20
            i1 = 4 * i - 3
            i2 = i1 + 1
            i3 = i1 + 2
            i4 = i1 + 3
            For j = 1 To 20
                j1 = 4 * j - 3
                j2 = j1 + 1
                j3 = j1 + 2
                j4 = j1 + 3
                Ek(i1, j1) = Bkx(i, j) + Exx(i, j)
                Ek(i1, j2) = Exy(i, j)
                Ek(i1, j3) = Exz(i, j)
                Ek(i2, j1) = Eyx(i, j)
                Ek(i2, j2) = Bky(i, j) + Eyy(i, j)
                Ek(i2, j3) = Eyz(i, j)
                Ek(i3, j1) = Ezx(i, j)
                Ek(i3, j2) = Ezy(i, j)
                Ek(i3, j3) = Bkz(i, j) + Ezz(i, j)
                Ek(i1, j4) = Hx(i, j)
                Ek(i2, j4) = Hy(i, j)
                Ek(i3, j4) = Hz(i, j)
                Ek(i4, j1) = Hsx(i, j)
                Ek(i4, j2) = Hsy(i, j)
                Ek(i4, j3) = Hsz(i, j)
                Ek(i4, j4) = Hp(i, j)
            Next j
        Next i

        If mtg > 0 Then
            For i = 1 To 20
                b1 = 0
                For j = 1 To 20
                    b2 = Math.Abs(Exx(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Exy(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Exz(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                Next j
                If b1 <> 0 Then
                    b2 = Math.Abs(RM(i) / b1)
                    If b2 < RateMAmax Then
                        RateMAmax = b2
                    End If
                End If
                b1 = 0
                For j = 1 To 20
                    b2 = Math.Abs(Eyx(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Eyy(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Eyz(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                Next j
                If b1 <> 0 Then
                    b2 = Math.Abs(RM(i) / b1)
                    If b2 < RateMAmax Then
                        RateMAmax = b2
                    End If
                End If
                b1 = 0
                For j = 1 To 20
                    b2 = Math.Abs(Ezx(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Ezy(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Ezz(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                Next j
                If b1 <> 0 Then
                    b2 = Math.Abs(RM(i) / b1)
                    If b2 < RateMAmax Then
                        RateMAmax = b2
                    End If
                End If
            Next i
        End If

    End Sub

    Private Sub DebugEK(ByVal nx As Integer)
        '要素ﾏﾄﾘｯｸｽを出力して停止
        'nx･･･変数の数
        Dim aa$, fdebug$
        Dim i, id, ii, j As Integer

        aa$ = ""
        ii = FreeFile()
        fdebug$ = DirOpen$ + "\Flow3Ddebug.dat"
        FileOpen(ii, fdebug$, OpenMode.Output)
        WriteLine(ii, "要素マトリックスE")
        For i = 1 To nx
            aa$ = "行" + Str(i)
            WriteLine(ii, aa$)
            id = 0
            For j = 1 To nx
                If id = 0 Then
                    aa$ = Str(Ek(i, j))
                Else
                    aa$ = aa$ + ",  " + Str(Ek(i, j))
                End If
                If id = 4 Then
                    PrintLine(ii, aa$)
                    id = 0
                Else
                    id = id + 1
                End If
            Next j
            If id <> 0 Then
                PrintLine(ii, aa$)
            End If
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub DebugLcomp(ByVal nx As Integer)
        '元の変数の縮小変数番号を出力して停止
        'nx･･･変数の数
        Dim a1$, aa$, fdebug$
        Dim i, id, ii As Integer

        aa$ = ""
        ii = FreeFile()
        fdebug$ = DirOpen$ + "\Flow3Ddebug.dat"
        FileOpen(ii, fdebug$, OpenMode.Output)
        id = 0
        For i = 1 To nx
            a1$ = "元の変数No." + Str(i) + ",  "
            a1$ = a1$ + "縮小変数No." + Str(Lcomp(i))
            If id = 0 Then
                aa$ = a1$
            Else
                aa$ = aa$ + ",   " + a1$
            End If
            If id = 4 Then
                PrintLine(ii, aa$)
                id = 0
                aa$ = ""
            Else
                id = id + 1
            End If
        Next i
        If id <> 0 Then
            PrintLine(ii, aa$)
        End If
        FileClose(ii)
        Stop
    End Sub

    Private Sub DebugTf(ByVal nx As Integer)
        '右辺ﾍﾞｸﾄﾙを出力して停止
        'nx･･･変数の数
        Dim aa$, fdebug$
        Dim i, id, ii As Integer
        Dim z1 As Single

        aa$ = ""
        ii = FreeFile()
        fdebug$ = DirOpen$ + "\Flow3Ddebug.dat"
        FileOpen(ii, fdebug$, OpenMode.Output)
        id = 0
        For i = 1 To nx
            z1 = Str(Tf(i))
            If id = 0 Then
                aa$ = Str(i) + ",  " + Str(z1)
            Else
                aa$ = aa$ + ",   " + Str(i) + ",  " + Str(z1)
            End If
            If id = 4 Then
                PrintLine(ii, aa$)
                id = 0
            Else
                id = id + 1
            End If
        Next i
        If id <> 0 Then
            PrintLine(ii, aa$)
        End If
        FileClose(ii)
        Stop
    End Sub

    Private Sub DebugTK(ByVal nx As Integer)
        'Tkﾏﾄﾘｯｸｽを出力して停止
        '非0要素のみ出力
        'nx･･･変数の数
        Dim aa$, fdebug$
        Dim i, id, ii, j, jj As Integer
        Dim z1 As Single

        aa$ = ""
        ii = FreeFile()
        fdebug$ = DirOpen$ + "\Flow3Ddebug.dat"
        FileOpen(ii, fdebug$, OpenMode.Output)
        For i = 1 To nx
            aa$ = "行" + Str(i)
            WriteLine(ii, aa$)
            z1 = Tk(KrowDpos(i))
            aa$ = "対角要素の値＝" + Str(z1)
            WriteLine(ii, aa$)
            id = 0
            For j = Krowpos(i) To Krowpos(i + 1) - 1
                jj = Jcolnum(j)
                z1 = Tk(j)
                If z1 <> 0 Then
                    If id = 0 Then
                        aa$ = Str(jj) + ",  " + Str(z1)
                    Else
                        aa$ = aa$ + ",   " + Str(jj) + ",  " + Str(z1)
                    End If
                    If id = 4 Then
                        PrintLine(ii, aa$)
                        id = 0
                    Else
                        id = id + 1
                    End If
                End If
            Next j
            If id <> 0 Then
                PrintLine(ii, aa$)
            End If
            z1 = Tf(i)
            WriteLine(ii, "    右辺", z1)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub DebugVolume(ByVal nx As Integer)
        '要素体積を出力して停止
        'nx･･･変数の数
        Dim aa$, fdebug$
        Dim i, id, ii As Integer

        aa$ = ""
        ii = FreeFile()
        fdebug$ = DirOpen$ + "\Flow3DdebugVol.dat"
        FileOpen(ii, fdebug$, OpenMode.Output)
        aa$ = "要素No.、体積"
        WriteLine(ii, aa$)
        id = 0
        For i = 1 To nx
            If id = 0 Then
                aa$ = Str(i) + ",  " + Str(VolE(i))
            Else
                aa$ = aa$ + ",   " + Str(i) + ",  " + Str(VolE(i))
            End If
            If id = 4 Then
                PrintLine(ii, aa$)
                id = 0
            Else
                id = id + 1
            End If
        Next i
        If id <> 0 Then
            PrintLine(ii, aa$)
        End If
        FileClose(ii)
        Stop
    End Sub

    Private Sub DiagCheck()
        '対角ﾁｪｯｸ
        Dim i, k As Integer
        Dim b1 As Single
        For i = 1 To Neff
            k = KrowDpos(i)
            b1 = Tk(k)
            If b1 < 0 Then
                Stop
            End If
        Next i

    End Sub

    Private Sub DvelCalc(ByRef dvelx As Double)
        '最大速度変化の計算
        'dvelx･･･最大速度変化値
        Dim ip, j, jj, k As Integer
        Dim b1 As Double

        dvelx = 0
        For ip = 1 To Npoint
            j = Ndim * (ip - 1) + 1
            For k = 0 To 2
                jj = Lcomp(j + k)
                If jj > 0 Then
                    b1 = Math.Abs(Tff(jj) - Tffx(jj))
                    If b1 > dvelx Then
                        dvelx = b1
                    End If
                End If
            Next k
        Next ip

    End Sub

    Private Sub ElemLengthCalc()
        '要素長の計算
        Dim ie, ig, jg, kg, numg As Integer
        Dim dj, dv, s, t, u, vsum As Double
        ReDim HElem(Nelem)

        For ie = 1 To Nelem
            Call CalcPrep(ie)       '要素ﾏﾄﾘｯｸｽの計算準備
            vsum = 0
            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)    '形状関数の計算
                            Call JacobElem(ie, 1, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            vsum = vsum + dv
                        Next kg
                    Next jg
                Next ig
            End If
            HElem(ie) = (6 * vsum / Pai) ^ 0.3333
        Next ie

    End Sub

    Private Sub ElemMatrix(ByVal ik As Integer, ByVal ie As Integer,
         ByVal kindvisc As Integer, ByVal mtg As Integer)
        '流れの要素ﾏﾄﾘｯｸｽ計算
        'ik･･･繰返し回数
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        'mtg･･･対流項の有無（0:なし、1:有り)
        'jj･･･分割行列の変数の数、対象変数なしの場合は-1を返す
        Dim i, j, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nvf
            For j = 1 To Nvf
                Ek(i, j) = 0
            Next j
        Next i
        For i = 1 To nmax
            RM(i) = 0
            For j = 1 To nmax
                Bkx(i, j) = 0
                Bky(i, j) = 0
                Bkz(i, j) = 0
                Exx(i, j) = 0
                Exy(i, j) = 0
                Exz(i, j) = 0
                Eyx(i, j) = 0
                Eyy(i, j) = 0
                Eyz(i, j) = 0
                Ezx(i, j) = 0
                Ezy(i, j) = 0
                Ezz(i, j) = 0
                Hsx(i, j) = 0
                Hsy(i, j) = 0
                Hsz(i, j) = 0
                Hx(i, j) = 0
                Hy(i, j) = 0
                Hz(i, j) = 0
                Hp(i, j) = 0
            Next j
            For j = 1 To 4
                ForceB(i, j) = 0
            Next j
        Next i
        If Mstat = 0 Then
            Call CalcPrep(ie)       '要素ﾏﾄﾘｯｸｽの計算準備
        Else
            Call CalcPrepT(ie)       '要素ﾏﾄﾘｯｸｽの計算準備
        End If
        Call CalcParam(ie, kindvisc)   '安定化ﾊﾟﾗﾒｰﾀｰの計算
        If Mstat = 0 Then
            If KindElem = 0 Then
                Call CoefMatrix(ie, kindvisc, mtg)  '係数ﾏﾄﾘｯｸｽの計算
            End If
        Else
            If KindElem = 0 Then
                Call CoefMatrixT(ie, kindvisc, mtg)  '係数ﾏﾄﾘｯｸｽの計算
            End If
        End If

    End Sub

    Private Sub FlowAnalysis(ByVal ik As Integer)
        '流れ解析
        'ik･･･繰返し回数
        Dim aa$, timn$
        Dim i, icount, ie As Integer
        Dim k, kindvisc, mtg As Integer
        Dim ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        For i = 1 To Neff
            Tf(i) = 0
        Next i
        For i = 1 To NumEff
            Tk(i) = 0
        Next i

        If ik = 1 Then
            kindvisc = 0
            mtg = 0
        Else
            kindvisc = 1
            mtg = 1
        End If

        icount = 0
        For ie = 1 To Nelem
            aa$ = "要素" + Str$(ie) + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            Call ElemMatrix(ik, ie, kindvisc, mtg) '流れの要素ﾏﾄﾘｯｸｽの計算
            Call Store()       '流れ計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For i = 1 To NBvar
            k = KBfix(i)
            ub = VBfix(i)
            If Kreverse > 0 And KBkind(i) > 0 Then
                ub = ub * RatePress1
            End If
            Call RestCond(k, ub) '拘束条件処理
        Next i

        'Call DiagCheck()    '対角ﾁｪｯｸ
        If ik > 1 Then
            Call MatrixCheck2()   '行列ﾁｪｯｸ2
        End If

        Call BCGStabL(Neff, NumEff)  'BCGStab(l)法ｿﾙﾊﾞｰ計算

        gr.Dispose()

    End Sub

    Private Sub FlowAnalysisT()
        '非定常の流れ解析
        'ik･･･繰返し回数
        Dim aa$, timn$
        Dim i, icount, ie As Integer
        Dim k, kindvisc, mtg As Integer
        Dim z1 As Single
        Dim ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        aa$ = ""
        timn$ = ""
        For i = 1 To Neff
            Tf(i) = 0
        Next i
        For i = 1 To NumEff
            Tk(i) = 0
        Next i

        kindvisc = 1
        If KindFlow = 0 And Kconv = 0 Then
            mtg = 0
        Else
            mtg = 1
        End If

        'mtg = 0
        'Call DebugLcomp(Neff)

        RateMAmax = 1.0E+32

        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(2, ie, kindvisc, mtg) '流れの要素ﾏﾄﾘｯｸｽ計算
            Call Store()       '流れ計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        'Call DebugTK(Neff)

        If Dtime > RateMAmax Then
            z1 = Dtime / RateMAmax
            aa$ = "計算時間間隔が" + Str$(z1) + "倍ぐらい大き過ぎます！"
            MsgBox(aa$, 0, "計算エラー")
            End
        End If

        For i = 1 To NBvar
            k = KBfix(i)
            ub = VBfix(i)
            Call RestCond(k, ub) '拘束条件処理
        Next i

        Call BCGStabL(Neff, NumEff)  'BCGStab(l)法ｿﾙﾊﾞｰ計算

        gr.Dispose()

    End Sub

    Private Sub FluctCheckT(ByRef aat As Double, ByRef bbt As Double)
        '温度の発散ﾁｪｯｸ
        'aat･･･温度解の最大値
        'bbt･･･温度解変化量の総和
        Dim ip As Integer
        Dim cc, dd As Double
        aat = 0
        bbt = 0
        For ip = 1 To Npoint
            cc = Math.Abs(Tf(ip))
            dd = Math.Abs(Tf(ip) - Told(ip))
            If cc > aat Then
                aat = cc
            End If
            If dd > bbt Then
                bbt = dd
            End If
        Next ip

    End Sub

    Private Sub FluctCheckV(ByRef bb As Double, ByRef bba As Double)
        '速度の発散ﾁｪｯｸ
        'bb･･･速度解変化量の最大値
        'bba･･･収束基準量（速度解最大値×収束基準変化率）
        Dim i, ip, k, kb As Integer
        Dim aa, cc, dd As Double
        aa = 0
        bb = 0
        For ip = 1 To Npoint
            k = Ndim * (ip - 1)
            For i = 1 To 3
                kb = Lcomp(k + i)
                If kb > 0 Then
                    cc = Math.Abs(Tf(kb))
                    dd = Math.Abs(Tf(kb) - Vold(kb))
                    If cc > aa Then
                        aa = cc
                    End If
                    If dd > bb Then
                        bb = dd
                    End If
                End If
            Next i
        Next ip
        bba = aa * EpsCalc

    End Sub

    Private Sub FvolumeCalc(ByRef kh As Integer, ByVal kout As Integer,
        ByVal velmax As Double, ByRef zvel1 As Single)
        '要素辺の流出入量の計算
        'kh･･･ｴﾗｰ有無（0:なし、-1:有り）
        'kout･･･出力の有無
        'velmax･･･最大流速（絶対値）
        'zvel1･･･入口側の平均流速
        Dim aa$
        Dim i, ib, icc, id, ie, j, jd, jj, jmax As Integer
        Dim k, k1, k2, kgp1, kgp2, kind, kb, kk, kmax, kx, m, nmax, numg As Integer
        Dim c1, c2, zarea, zarea1, zarea2, zqv, zqv1, zqv2 As Single
        Dim zvel, zvel2 As Single
        Dim b1, da, dj, gp1, gp2, ugb, velcut, veln, vgb, wgb As Double
        Dim kbuf(8) As Integer
        Dim gpos(3), sbuf(2, 3), snbuf(3), svbuf(2, 3) As Double
        ReDim KdrawElem(Nelem), KSelem(Nelem, 6)

        If KindElem = 0 Then
            jmax = 8
            kmax = 6
            nmax = 20
        End If
        velcut = velmax * 0.00001

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie
        Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ

        If kout > 0 Then
            SwK.WriteLine("＊＊ 要素面の流出入量の出力 ＊＊")
            SwK.WriteLine("＜要素番号、面番号、面積、流出量、平均流速＞")
        End If

        zarea1 = 0 : zarea2 = 0 '流入、流出の合計面積
        zqv1 = 0 : zqv2 = 0 '流入、流出の合計量
        For ie = 1 To Nelem
            For k = 1 To kmax
                If KSelem(ie, k) = 0 Then   '外郭面の場合
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, k, KsurfPoint)    '面の設定
                    End If
                    icc = 0
                    For j = 1 To jmax
                        kb = KsurfPoint(j)
                        kx = Ndim * (Kcomp(kb) - 1)
                        For m = 1 To 3
                            If Lcomp(kb + m) > 0 Then
                                icc = 1
                                Exit For
                            End If
                        Next m
                    Next j
                    If icc > 0 Then
                        If KindElem = 0 Then
                            Call SurfaceCond(k, kind, kbuf, gpos)
                            '境界条件用の面設定
                        End If

                        For i = 1 To nmax
                            ib = NNelem(ie, i)
                            XE(i) = Xdata(ib)
                            YE(i) = Ydata(ib)
                            ZE(i) = Zdata(ib)
                            kx = Ndim * (Kcomp(ib) - 1)
                            For m = 1 To 3
                                kk = Lcomp(kx + m)
                                Select Case m
                                    Case 1
                                        UE(i) = Tff(kk)
                                    Case 2
                                        VE(i) = Tff(kk)
                                    Case 3
                                        WE(i) = Tff(kk)
                                End Select
                            Next m
                        Next i

                        zarea = 0   '面積
                        zqv = 0     '流出入量
                        If KindElem = 0 Then
                            Select Case kind
                                Case 1
                                    kgp1 = 1
                                    kgp2 = 2
                                    jj = 3
                                Case 2
                                    kgp1 = 1
                                    kgp2 = 3
                                    jj = 2
                                Case 3
                                    kgp1 = 2
                                    kgp2 = 3
                                    jj = 1
                            End Select

                            numg = 0
                            For k1 = 1 To Ngaus
                                gp1 = PosGaus(k1)
                                For k2 = 1 To Ngaus
                                    gpos(kgp1) = gp1
                                    gpos(kgp2) = PosGaus(k2)
                                    gp2 = gpos(kgp2)
                                    numg = numg + 1
                                    Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                                    '形状関数の計算

                                    Call JacobElem2S(1, ie, numg, dj, kbuf)
                                    '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                                    ugb = UG(numg)
                                    vgb = VG(numg)
                                    wgb = WG(numg)
                                    da = 0
                                    For i = 1 To 3
                                        b1 = RinvJ(i, jj)
                                        da = da + b1 * b1
                                    Next i
                                    da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                                    zarea = zarea + da

                                    '面の法線ﾍﾞｸﾄﾙの計算
                                    For j = 1 To 2
                                        For m = 1 To 2
                                            If m = 1 Then
                                                Select Case j
                                                    Case 1
                                                        gpos(kgp1) = gp1 - 0.01
                                                    Case 2
                                                        gpos(kgp1) = gp1
                                                        gpos(kgp2) = gp2 - 0.01
                                                End Select
                                            Else
                                                Select Case j
                                                    Case 1
                                                        gpos(kgp1) = gp1 + 0.01
                                                    Case 2
                                                        gpos(kgp2) = gp2 + 0.01
                                                End Select
                                            End If
                                            Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                                            '形状関数の計算

                                            Call JacobElem2S(0, ie, numg, dj, kbuf)
                                            '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                                            sbuf(m, 1) = XG(numg)
                                            sbuf(m, 2) = YG(numg)
                                            sbuf(m, 3) = ZG(numg)
                                        Next m
                                        For jd = 1 To 3
                                            svbuf(j, jd) = sbuf(2, jd) - sbuf(1, jd)
                                        Next jd
                                    Next j
                                    snbuf(1) = svbuf(1, 2) * svbuf(2, 3) - svbuf(1, 3) * svbuf(2, 2)
                                    snbuf(2) = svbuf(1, 3) * svbuf(2, 1) - svbuf(1, 1) * svbuf(2, 3)
                                    snbuf(3) = svbuf(1, 1) * svbuf(2, 2) - svbuf(1, 2) * svbuf(2, 1)
                                    id = 0
                                    If kind = 2 Then
                                        If gpos(2) > 0 Then
                                            id = 1
                                        End If
                                    Else
                                        If gpos(jj) < 0 Then
                                            id = 1
                                        End If
                                    End If
                                    If id > 0 Then
                                        For m = 1 To 3
                                            snbuf(m) = -snbuf(m)
                                        Next m
                                    End If
                                    b1 = 0
                                    For m = 1 To 3
                                        b1 = b1 + snbuf(m) * snbuf(m)
                                    Next m
                                    b1 = Math.Sqrt(b1)
                                    For m = 1 To 3
                                        snbuf(m) = snbuf(m) / b1
                                    Next m
                                    veln = ugb * snbuf(1) + vgb * snbuf(2)
                                    veln = veln + wgb * snbuf(3)
                                    zqv = zqv + veln * da
                                Next k2
                            Next k1
                        End If

                        zvel = zqv / zarea
                        If Math.Abs(zvel) > velcut Then
                            If kout > 0 Then
                                aa$ = Str$(ie)
                                aa$ = aa$ + ",  " + Str$(k)
                                aa$ = aa$ + ",  " + Str$(zarea)
                                aa$ = aa$ + ",  " + Str$(zqv)
                                aa$ = aa$ + ",  " + Str$(zvel)
                                SwK.WriteLine(aa$)
                            End If
                            If zqv < 0 Then
                                zqv1 = zqv1 + zqv
                                zarea1 = zarea1 + zarea
                            Else
                                zqv2 = zqv2 + zqv
                                zarea2 = zarea2 + zarea
                            End If
                        End If
                    End If
                End If
            Next k
        Next ie
        If zarea1 = 0 Then
            zvel1 = 0
        Else
            zvel1 = zqv1 / zarea1
        End If
        If kout > 0 Then
            If zarea2 = 0 Then
                zvel2 = 0
            Else
                zvel2 = zqv2 / zarea2
            End If
            SwK.WriteLine("［流入側合計］")
            aa$ = "  面積" + "," + Str(zarea1)
            SwK.WriteLine(aa$)
            aa$ = "  流量" + "," + Str(zqv1)
            SwK.WriteLine(aa$)
            aa$ = "  平均流速" + "," + Str(zvel1)
            SwK.WriteLine(aa$)
            SwK.WriteLine("［流出側合計］")
            aa$ = "  面積" + "," + Str(zarea2)
            SwK.WriteLine(aa$)
            aa$ = "  流量" + "," + Str(zqv2)
            SwK.WriteLine(aa$)
            aa$ = "  平均流速" + "," + Str(zvel2)
            SwK.WriteLine(aa$)
        End If

        kh = 0
        c1 = -zqv1
        c2 = zqv2
        If (c1 > 0 And c2 = 0) Or (c1 = 0 And c2 > 0) Then
            kh = -1
        ElseIf c1 > 0 And c2 > 0 Then
            If c1 > c2 Then
                c2 = c1
                c1 = zqv2
            End If
            c1 = c1 / c2
            If c1 < 0.9 Then    '流量不釣り合い
                kh = -1
            End If
        End If

    End Sub


    Private Sub HeatFluxSet()
        '熱流束の節点への換算
        Dim i, ib, ie, ii, j, jj, k1, k2, kb, kgp1, kgp2 As Integer
        Dim kind, kk, nmax, numg As Integer
        Dim b1, da, dj, pnb As Double
        Dim kbuf(8) As Integer
        Dim gpos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Nflux
            ie = KsurfFlux(ii, 1)
            kb = KsurfFlux(ii, 2)
            Call SurfaceCond(kb, kind, kbuf, gpos)
            '境界条件用の面設定

            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j
            Select Case kind
                Case 1
                    kgp1 = 1
                    kgp2 = 2
                    jj = 3
                Case 2
                    kgp1 = 1
                    kgp2 = 3
                    jj = 2
                Case 3
                    kgp1 = 2
                    kgp2 = 3
                    jj = 1
            End Select

            pnb = Pnorm(ii)
            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select

                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            Tf(j) = Tf(j) - pnb * Shape(kk) * da
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub InitDataSet()
        '初期値設定
        Dim i, ib, j, jj, k, kb As Integer
        If InitDataV > 0 Then
            For i = 1 To Npoint
                ib = Kcomp(i)
                k = Ndim * (ib - 1)
                For j = 1 To Ndim
                    jj = k + j
                    kb = Lcomp(jj)
                    If kb > 0 Then
                        Tffx(kb) = Vinit(i, j)
                    End If
                Next j
            Next i
        End If
        For i = 1 To NBvar
            kb = KBfix(i)
            Tffx(kb) = VBfix(i)
        Next i
        For i = 1 To Neff
            Tff(i) = Tffx(i)
            Vold(i) = Tffx(i)
        Next i

        If KindTherm > 0 Then
            If Tempi <> -1 Then
                For i = 1 To Npoint
                    Tftx(i) = Tempi
                Next i
            ElseIf InitDataT > 0 Then
                For i = 1 To Npoint
                    Tftx(Kcomp(i)) = TempInit(i)
                Next i
            End If
            For i = 1 To Npoint
                If NTrest(i) > 0 Then
                    Tftx(i) = TempFix(i)
                End If
            Next i
            For i = 1 To Npoint
                Tft(i) = Tftx(i)
                Told(i) = Tftx(i)
                Toldx(i) = Tftx(i)
            Next i
        End If

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ic, icc, ie, ii, imax, ip, j, jb, jj, jmax, jx, nmax As Integer
        Dim k, kb, nex As Integer
        Dim kbuf(8) As Integer

        If KindElem = 0 Then
            Nvf = 80
            imax = 6
            jmax = 8
            nmax = 20
        End If
        '速度・圧力固定ﾃﾞｰﾀの処理
        Dim jfix(Npoint, Ndim) As Integer
        Dim vfix(Npoint, Ndim) As Single
        If NboundP > 0 Then
            For i = 1 To NboundP
                k = Kcomp(NrestP(i))
                For j = 1 To Ndim
                    jfix(k, j) = JfixP(i, j)
                    vfix(k, j) = VfixP(i, j)
                Next j
            Next i
        End If
        If NboundS > 0 Then
            For i = 1 To NboundS
                ie = KsurfRest(i, 1)
                kb = KsurfRest(i, 2)
                If KindElem = 0 Then
                    Call SurfaceSet(ie, kb, kbuf)   '面の設定
                End If
                For j = 1 To jmax
                    k = Kcomp(kbuf(j))
                    For jj = 1 To Ndim
                        jx = JfixS(i, jj)
                        If jx > 0 Then
                            If jfix(k, jj) = 0 Then
                                jfix(k, jj) = jx
                                vfix(k, jj) = VfixS(i, jj)
                            End If
                        ElseIf jx < 0 Then
                            jfix(k, jj) = jx
                            vfix(k, jj) = VfixS(i, jj)
                        End If
                    Next jj
                Next j
            Next i
        End If

        If KindWall = 0 Then    '壁面の自動設定の場合
            ReDim KdrawElem(Nelem), KSelem(Nelem, 6)
            For ie = 1 To Nelem
                KdrawElem(ie) = 1
            Next ie
            Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ
            For ie = 1 To Nelem
                For i = 1 To imax
                    If KSelem(ie, i) = 0 Then   '外郭面の場合
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, i, kbuf)   '面の設定
                        End If
                        ic = 0 '壁面ﾌﾗｯｸﾞのｸﾘｱ（1は壁面にしない）
                        jb = 0
                        For j = 1 To jmax
                            k = Kcomp(kbuf(j))
                            For jj = 1 To 3
                                jx = jfix(k, jj)
                                If jx < 0 Then
                                    If j = jb Or j = jb + 1 Then
                                        jb = j
                                    Else
                                        jb = -1 '強制非壁面でない
                                    End If
                                ElseIf jx > 0 And vfix(k, jj) <> 0 Then
                                    ic = 1
                                    Exit For
                                End If
                            Next jj
                            If ic > 0 Then
                                Exit For
                            End If
                        Next j
                        If jb = jmax Then
                            ic = 1
                        End If
                        If ic = 0 Then
                            icc = 0
                            For j = 1 To jmax
                                k = Kcomp(kbuf(j))
                                If jfix(k, 4) = 0 Then
                                    icc = 1
                                    Exit For
                                End If
                            Next j
                            If icc = 0 Then
                                ic = 1
                            End If
                        End If
                        If ic = 0 Then  '壁面の場合
                            KSelem(ie, i) = -1
                        End If
                    End If
                Next i
            Next ie
            For ie = 1 To Nelem
                For i = 1 To imax
                    If KSelem(ie, i) < 0 Then   '壁面の場合
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, i, kbuf)   '面の設定
                        End If
                        For j = 1 To jmax
                            k = Kcomp(kbuf(j))
                            For jj = 1 To 3
                                jfix(k, jj) = 1
                                vfix(k, jj) = 0
                            Next jj
                        Next j
                    End If
                Next i
            Next ie
        End If

        '温度固定ﾃﾞｰﾀの処理
        If KindTherm > 0 Then
            ReDim NTrest(Npoint), TempFix(Npoint)
            Dim kkbuf(Npoint) As Integer
            If Nflux > 0 Then
                For i = 1 To Nflux
                    ie = KsurfFlux(i, 1)
                    kb = KsurfFlux(i, 2)
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    End If
                    For j = 1 To jmax
                        k = Kcomp(kbuf(j))
                        kkbuf(k) = -1   '熱流束のフラッグ
                    Next j
                Next i
            End If
            If NBtempP > 0 Then
                For i = 1 To NBtempP
                    k = Kcomp(NTrestP(i))
                    If kkbuf(k) = 0 Then    '熱流束の節点を除く
                        NTrest(k) = 1
                        TempFix(k) = TempFixP(i)
                    End If
                Next i
            End If
            If NBtempS > 0 Then
                For i = 1 To NBtempS
                    ie = KsurfTrest(i, 1)
                    kb = KsurfTrest(i, 2)
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    End If
                    For j = 1 To jmax
                        k = Kcomp(kbuf(j))
                        If NTrest(k) = 0 And kkbuf(k) = 0 Then
                            NTrest(k) = 1
                            TempFix(k) = TempFixS(i)
                        End If
                    Next j
                Next i
            End If
            'If KindWall = 0 Then    '壁面の自動設定の場合
            If KindWall = 0 And TempWall <> -1 Then    '壁面の自動設定の場合
                For ie = 1 To Nelem
                    'For i = 1 To 6
                    For i = 1 To imax
                        If KSelem(ie, i) < 0 Then  '壁面の場合
                            If KindElem = 0 Then
                                Call SurfaceSet(ie, i, kbuf)   '面の設定
                            End If
                            For j = 1 To jmax
                                k = Kcomp(kbuf(j))
                                If NTrest(k) = 0 And kkbuf(k) = 0 Then
                                    NTrest(k) = 1
                                    TempFix(k) = TempWall
                                End If
                            Next j
                        End If
                    Next i
                Next ie
            End If
        End If

        ReDim NPrefer(Nvf), NPrefT(20)
        Nall = Ndim * Npoint
        ReDim Lcomp(Nall)
        For i = 1 To Nall       '全変数のﾏﾄﾘｯｸｽ組み入れを仮設定
            Lcomp(i) = 1
        Next i

        nex = 0
        For ip = 1 To Npoint    '0固定の速度･圧力変数の除去
            jb = Ndim * (ip - 1)
            For j = 1 To 4
                If jfix(ip, j) <> 0 And vfix(ip, j) = 0 Then
                    jj = jb + j
                    If Lcomp(jj) > 0 Then
                        nex = nex + 1
                        Lcomp(jj) = 0
                    End If
                End If
            Next j
        Next ip

        Neff = Nall - nex
        j = 0
        For i = 1 To Nall       '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
            If Lcomp(i) > 0 Then
                j = j + 1
                Lcomp(i) = j
            End If
        Next i

        '速度･圧力の非ｾﾞﾛ固定の整理
        NBvar = 0
        For ip = 1 To Npoint
            For j = 1 To 4
                If jfix(ip, j) <> 0 And vfix(ip, j) <> 0 Then
                    NBvar = NBvar + 1
                End If
            Next j
        Next ip
        ReDim KBfix(NBvar), KBkind(NBvar), VBfix(NBvar)
        i = 0 : jb = 0
        RatePress1 = 1
        For ip = 1 To Npoint
            For j = 1 To 4
                i = i + 1
                If jfix(ip, j) <> 0 And vfix(ip, j) <> 0 Then
                    jb = jb + 1
                    KBfix(jb) = Lcomp(i)
                    VBfix(jb) = vfix(ip, j)
                    If j = 4 Then
                        KBkind(jb) = 1
                    End If
                End If
            Next j
        Next ip

        ReDim KRelax(Neff)
        For i = 1 To Neff
            KRelax(i) = 1
        Next i
        For i = 1 To NBvar
            KRelax(KBfix(i)) = 0
        Next i

        ReDim Nw(Npoint)
        '節点の重複要素数の計算
        For ie = 1 To Nelem
            For ii = 1 To nmax
                i = Kcomp(NNelem(ie, ii))
                Nw(i) = Nw(i) + 1
            Next ii
        Next ie

    End Sub

    Private Sub InitialSet2()
        '初期設定2
        Dim aa$
        Dim i, ib, ic, id, ie, i1, ii, ip, j, k, kk As Integer
        Dim nb, nmax, num, numall, numallT As Integer
        Dim b1, freemem, reqmem As Single
        Dim nbuf(Npoint) As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        '関連節点数の計算
        numall = 0
        For i = 1 To Npoint
            ic = 0
            k = Ndim * (i - 1)
            For id = 1 To Ndim
                If Lcomp(k + id) > 0 Then
                    ic = 1
                    Exit For
                End If
            Next id
            If ic > 0 Then
                For j = 1 To Npoint
                    nbuf(j) = 0
                Next j
                ip = KRcomp(i)
                For ie = 1 To Nelem
                    ic = 0
                    For ii = 1 To nmax
                        If NNelem(ie, ii) = ip Then
                            ic = 1
                            Exit For
                        End If
                    Next ii
                    If ic > 0 Then
                        For ii = 1 To nmax
                            ib = Kcomp(NNelem(ie, ii))
                            nbuf(ib) = 1
                        Next ii
                    End If
                Next ie
                num = 0
                k = Ndim * (i - 1)
                For id = 1 To Ndim
                    If Lcomp(k + id) > 0 Then
                        For j = 1 To Npoint
                            If nbuf(j) > 0 Then
                                ii = Ndim * (j - 1)
                                For kk = 1 To Ndim
                                    If Lcomp(ii + kk) > 0 Then
                                        num = num + 1
                                    End If
                                Next kk
                            End If
                        Next j
                    End If
                Next id
                numall = numall + num
            End If
        Next i
        NumEff = numall

        freemem = 1000 * FreeMemoryGet()
        reqmem = 20.0 * NumEff * 1.05
        If reqmem > freemem Then
            b1 = reqmem / 100000000.0
            reqmem = (Int(b1) + 1) / 10
            aa$ = "変数の数が大き過ぎるため、配列変数のメモリーが足りません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "反復法で必要な空きメモリー容量は約"
            aa$ = aa$ + Str(reqmem) + "ＧＢです。"
            MsgBox(aa$, 0, "メモリー不足")
            End
        End If
        ReDim Tk(NumEff), Tk2(NumEff), Jcolnum(NumEff)

        '保存配列との関連付け
        numall = 0
        nb = 0
        For i = 1 To Npoint
            ic = 0
            k = Ndim * (i - 1)
            For id = 1 To Ndim
                If Lcomp(k + id) > 0 Then
                    ic = 1
                    Exit For
                End If
            Next id
            If ic > 0 Then
                For j = 1 To Npoint
                    nbuf(j) = 0
                Next j
                ip = KRcomp(i)
                For ie = 1 To Nelem
                    ic = 0
                    For ii = 1 To nmax
                        If NNelem(ie, ii) = ip Then
                            ic = 1
                            Exit For
                        End If
                    Next ii
                    If ic > 0 Then
                        For ii = 1 To nmax
                            ib = Kcomp(NNelem(ie, ii))
                            nbuf(ib) = 1
                        Next ii
                    End If
                Next ie

                k = Ndim * (i - 1)
                For id = 1 To Ndim
                    If Lcomp(k + id) > 0 Then
                        nb = nb + 1
                        Krowpos(nb) = numall + 1
                        For j = 1 To Npoint
                            If nbuf(j) > 0 Then
                                ii = Ndim * (j - 1)
                                For kk = 1 To Ndim
                                    If Lcomp(ii + kk) > 0 Then
                                        numall = numall + 1
                                        Jcolnum(numall) = Lcomp(ii + kk)
                                    End If
                                Next kk
                            End If
                        Next j
                    End If
                Next id
            End If
            If i = Npoint Then
                Krowpos(nb + 1) = numall + 1
            End If
        Next i

        For i = 1 To Neff
            Call StoreIndex(i, i, ib) '保存配列位置の算出
            KrowDpos(i) = ib
        Next i

        If KindTherm > 0 Then
            '関連節点数の計算
            numallT = 0
            For i = 1 To Npoint
                For j = 1 To i
                    nbuf(j) = 0
                Next j
                ip = KRcomp(i)
                For ie = 1 To Nelem
                    ic = 0
                    For ii = 1 To nmax
                        If NNelem(ie, ii) = ip Then
                            ic = 1
                            Exit For
                        End If
                    Next ii
                    If ic > 0 Then
                        For ii = 1 To nmax
                            ib = Kcomp(NNelem(ie, ii))
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        Next ii
                    End If
                Next ie
                i1 = 0
                For j = 1 To i
                    If nbuf(j) > 0 Then
                        i1 = j
                        Exit For
                    End If
                Next j
                num = i - i1 + 1
                NumDiagT(i) = num
                numallT = numallT + num
                IdiagT(i) = numallT
                numallT = numallT + num - 1
                NumEffT = numallT
            Next i

            If NumEffT > NumEff Then
                Try
                    ReDim Tk(NumEffT)
                Catch
                    aa$ = "温度計算のＦＥＭ行列のメモリーを確保できません！"
                    MsgBox(aa$, 0, "メモリー不足")
                    End
                End Try
            End If
        End If

    End Sub

    Private Sub MatrixCalc(ByRef iconv As Integer, ByVal ik As Integer, _
        ByVal mbh As Integer, ByVal mbht As Integer, ByRef bb As Double)
        'ﾏﾄﾘｯｸｽ計算
        'iconv･･･収束有無（0:なし、1:有り）
        'ik･･･繰返し回数
        'mbh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbht･･･温度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'bb･･･最大速度誤差
        Dim i As Integer
        'Dim bba As Double
        Dim bba, tfb, tfx, tfxx As Double

        iconv = 0
        Call FlowAnalysis(ik)      '流れ解析

        Call PressCheck()   '圧力のﾁｪｯｸ
        For i = 1 To Neff
            Tff(i) = Tf(i)
        Next i

        If KindFlow = 0 And KindTherm = 0 And Kconv = 0 Then
            iconv = 1
        Else
            If ik > 1 Then
                Call FluctCheckV(bb, bba)   '速度の発散ﾁｪｯｸ
                If ik = 2 And KindRelax > 0 Then
                    For i = 1 To Neff
                        If KRelax(i) > 0 Then
                            tfb = Tf(i)
                            tfx = Vold(i)
                            Call RelaxCalc2B(tfb, tfx) '緩和計算
                            Tf(i) = tfb
                            Tff(i) = tfb
                        End If
                    Next i
                End If

                If ik > 3 Then
                    If bba >= bb Then
                        iconv = 1
                    End If
                End If
                If ik > 2 Then
                    If bb > Svelold Then
                        For i = 1 To Neff
                            If KRelax(i) > 0 Then
                                tfb = Tf(i)
                                tfx = Vold(i)
                                tfxx = Voldx(i)
                                If KindRelax = 0 Then
                                    Call RelaxCalc(tfb, tfx, tfxx) '緩和計算
                                Else
                                    Call RelaxCalcB(tfb, tfx, tfxx) '緩和計算
                                End If
                                Tf(i) = tfb
                                Tff(i) = tfb
                            End If
                        Next i
                    End If
                End If
            End If

            Call FluctCheckV(bb, bba)   '速度の発散ﾁｪｯｸ
            If ik = NKmax Then
                If bba >= bb Then
                    iconv = 1
                End If
            End If
            Svelold = bb
        End If

        If KindTherm > 0 Then
            Application.DoEvents()
            Call TempAnalysis(ik, mbht)       '温度解析
        End If

    End Sub

    Private Sub MatrixCalcT(ByVal mbh As Integer, ByVal mbht As Integer)
        '非定常のﾏﾄﾘｯｸｽ計算
        'mbh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbht･･･温度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i As Integer

        Call FlowAnalysisT()   '非定常の流れ解析

        Call PressCheck()   '圧力のﾁｪｯｸ
        For i = 1 To Neff
            Tff(i) = Tf(i)
        Next i

        If Kinit > 0 Then
            Call RelaxTreat()   '緩和処理
        End If

        If KindTherm > 0 Then
            Application.DoEvents()
            Call TempAnalysisT(mbht)       '温度解析
        End If

    End Sub

    Private Sub MatrixCheck2()
        '行列ﾁｪｯｸ2
        Dim i, j, k As Integer
        Dim b1, b2, b3, b4, c1, c2 As Single
        c1 = 1.5   '最大比
        For i = 1 To Neff
            k = KrowDpos(i)
            b1 = Tk(k)
            b2 = 0
            For j = Krowpos(i) To Krowpos(i + 1) - 1
                If j <> k Then
                    b3 = Math.Abs(Tk(j))
                    If b3 > b2 Then
                        b2 = b3
                    End If
                End If
            Next j
            If b1 < b2 / c1 Then
                '改善処理
                c2 = c1 * b2
                b4 = c2 - b1
                Tf(i) = Tf(i) + b4 * Vold(i)
                Tk(k) = c2
            End If
        Next i

    End Sub

    Private Sub PressCheck()
        '圧力のﾁｪｯｸ・・・負圧は0に置換
        Dim ip, j, jj As Integer
        For ip = 1 To Npoint
            j = Ndim * (ip - 1)
            jj = Lcomp(j + 4)
            If Tf(jj) < 0 Then
                Tf(jj) = 0
            End If
        Next ip

    End Sub

    Private Sub PreVecCalc2(ByVal nx As Integer, ByVal vec() As Double, _
    ByRef cvec() As Double)
        'InvC･rvecの計算2
        'nx･･･ﾍﾞｸﾄﾙ次数
        'vec()･･･対象ﾍﾞｸﾄﾙ
        'cvec()･･･結果ﾍﾞｸﾄﾙ
        Dim i, j, jj As Integer
        For i = 1 To nx
            cvec(i) = vec(i)
        Next i
        For i = 1 To nx
            For j = Krowpos(i) To KrowDpos(i) - 1
                jj = Jcolnum(j)
                cvec(i) = cvec(i) - Tk2(j) * cvec(jj)
            Next j
            cvec(i) = cvec(i) / Tk2(KrowDpos(i))
        Next i
        For i = nx To 1 Step -1
            For j = KrowDpos(i) + 1 To Krowpos(i + 1) - 1
                jj = Jcolnum(j)
                cvec(i) = cvec(i) - Tk2(j) * cvec(jj)
            Next j
        Next i

    End Sub

    Private Sub RelaxPress2()
        '圧力の緩和1
        Dim ip, k, kb As Integer
        Dim tfb, tfnew, tfx, tfxx As Double
        For ip = 1 To Npoint
            k = Ndim * (ip - 1) + 4
            kb = Lcomp(k)
            If kb > 0 And KRelax(kb) > 0 Then
                tfb = Tf(kb)
                tfx = Vold(kb)
                tfxx = Voldx(kb)
                tfnew = RelaxCalF1(tfb, tfx) '緩和計算
                Tf(kb) = tfnew
                Tff(kb) = tfnew
            End If
        Next ip

    End Sub

    Private Sub RelaxTreat()
        '非定常の緩和処理
        Dim i As Integer
        Dim b1, b2, c1, t1, tfb As Double

        t1 = TimeNew - TimeStd
        If t1 > 0 Then
            c1 = Dtime / t1
        Else
            c1 = 1.5
        End If
        For i = 1 To Neff
            If KRelax(i) > 0 Then
                tfb = Tf(i)
                b1 = c1 * Math.Abs(Tffx(i) - Tff0(i))
                b2 = Math.Abs(tfb - Tffx(i))
                If b1 > 0 And b2 > b1 Then
                    b2 = b1
                End If
                If tfb < Tffx(i) Then
                    b2 = -b2
                End If
                Tf(i) = Tffx(i) + b2
                Tff(i) = Tf(i)
            End If
        Next i

    End Sub

    Private Sub RelaxVel2()
        '速度の緩和2
        Dim i, ip, k, kb As Integer
        Dim tfb, tfx, tfxx As Double
        For ip = 1 To Npoint
            k = Ndim * (ip - 1) + 1
            For i = 0 To 2
                kb = Lcomp(k + i)
                If kb > 0 And KRelax(kb) > 0 Then
                    tfb = Tf(kb)
                    tfx = Vold(kb)
                    tfxx = Voldx(kb)
                    Call RelaxCalc(tfb, tfx, tfxx) '緩和計算
                    Tf(kb) = tfb
                    Tff(kb) = tfb
                End If
            Next i
        Next ip

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ReqTimeT(ByVal rmesh As Single, ByVal rmeshsum As Single, _
    ByVal b1 As Double, ByVal b2 As Single)
        '非定常の残りの所要時間の計算
        'rmesh･･･ﾒｯｼｭ番号
        'rmeshsum･･･最大ﾒｯｼｭ番号
        'b1･･･流れの時間差
        'b2･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b3, b4 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        tima$ = ""
        If b2 < 0 Then
            b2 = b2 + 86400
        End If
        b3 = rmeshsum - rmesh
        b3 = TimeMax * b3 / rmeshsum
        b4 = b2 * b3 / b1
        Call TimConv(tima$, b4)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$, c1$, c2$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        c1$ = "＜＜３次元流れ解析の計算結果＞＞"
        If Kreverse > 0 Then
            c1$ = c1$ + "（入口速度対応の逆解析）"
        End If
        SwK.WriteLine(c1$)
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)
        aa$ = "解析種類（0:定常、1:非定常）" + "," + Str(Mstat)
        SwK.WriteLine(aa$)
        If Mstat > 0 Then
            c1$ = "計算打切り時間"
            c2$ = "出力時間メッシュ数"
            aa$ = c1$ + "," + Str(TimeMax) + "," + c2$ + "," + Str(Ntime)
            SwK.WriteLine(aa$)
            aa$ = "計算時間間隔の初期値" + "," + Str(DtimeInit)
            SwK.WriteLine(aa$)
            aa$ = "計算1回の速度変化許容値" + "," + Str(DvelMax)
            SwK.WriteLine(aa$)
        End If

        If KindFlow = 0 Then
            SwK.WriteLine("ニュートン流")
        Else
            SwK.WriteLine("非ニュートン流")
        End If

        If KindTherm = 0 Then
            SwK.WriteLine("等温流")
            If KindFlow > 0 Then
                aa$ = "一定の温度" + "," + Str(Tempi)
                SwK.WriteLine(aa$)
            End If
        Else
            SwK.WriteLine("非等温流")
            aa$ = "初期温度" + "," + Str(Tempi)
            SwK.WriteLine(aa$)
        End If

        If KindWall = 0 Then
            SwK.WriteLine("壁面の自動設定有")
            If KindTherm > 0 Then
                aa$ = "  壁面の一括設定温度" + "," + Str(TempWall)
                SwK.WriteLine(aa$)
            End If
        Else
            SwK.WriteLine("壁面の自動設定なし")
        End If

        If KindRelax = 0 Then
            SwK.WriteLine("粘度の種別：高粘度（樹脂等）")
        Else
            SwK.WriteLine("粘度の種別：低粘度用（水等）")
        End If

        If Kconv = 0 Then
            SwK.WriteLine("対流項なし")
        Else
            SwK.WriteLine("対流項有り")
        End If

        If Kreverse > 0 Then
            aa$ = "入口平均流速の絶対値" + "," + Str(VelAve)
            SwK.WriteLine(aa$)
            aa$ = "平均流速の誤差許容値" + "," + Str(DvelMax)
            SwK.WriteLine(aa$)
        End If

        If Mstat = 0 Then
            If KindFlow > 0 Or Kconv > 0 Then
                aa$ = "最大繰り返し計算回数" + "," + Str(NKmax)
                SwK.WriteLine(aa$)
                aa$ = "収束基準誤差率" + "," + Str(EpsCalc)
                SwK.WriteLine(aa$)
            End If
        End If

        aa$ = "安定化τpの追加係数" + "," + Str(Cratio)
        SwK.WriteLine(aa$)

        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile2(ByVal mbf As Integer, ByVal mbft As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mbf･･･流れ計算ﾊﾞﾝﾄﾞ幅(ﾌﾙ)
        'mbft･･･温度計算ﾊﾞﾝﾄﾞ幅(ﾌﾙ)
        Dim aa$

        aa$ = "流れ計算マトリックスの変数個数、バンド幅、保存インデックス数"
        SwK.WriteLine("＊＊＊ 計算結果（反復法） ＊＊＊")
        SwK.WriteLine(aa$)
        aa$ = "   " + Str(Neff) + ",   " + Str(mbf) + ",   " + Str(NumEff)
        SwK.WriteLine(aa$)
        If KindTherm > 0 Then
            aa$ = "温度計算マトリックスの変数個数、バンド幅、保存インデックス数"
            SwK.WriteLine(aa$)
            aa$ = "   " + Str(Npoint) + ",   " + Str(mbft) + ",   " + Str(NumEffT)
            SwK.WriteLine(aa$)
        End If

    End Sub

    Private Sub ResFile3(ByVal ikb As Integer, ByRef velmax As Double, _
        ByVal zdvel As Single)
        '結果ﾌｧｲﾙへの出力3
        'ikb･･･計算繰り返し回数
        'velmax･･･最大流速（絶対値）
        'zdvel･･･最大速度誤差
        Dim aa$
        Dim i1, ii, ip, j, jj, k As Integer
        Dim b1, b2 As Double
        Dim zbuf(5) As Single

        aa$ = "計算繰り返し回数" + "," + Str(ikb)
        SwK.WriteLine(aa$)
        If ikb > 1 Then
            aa$ = "最大速度誤差" + "," + Str(zdvel)
            SwK.WriteLine(aa$)
        End If
        If Kreverse > 0 Then
            aa$ = "入口圧力の修正比" + "," + Str(RatePress1)
            SwK.WriteLine(aa$)
        End If
        aa$ = "＜節点番号、速度Ｕ、速度Ｖ、速度Ｗ、圧力"
        If KindTherm = 0 Then
            aa$ = aa$ + "＞"
        Else
            aa$ = aa$ + "、温度＞"
        End If
        SwK.WriteLine("＊＊ 速度・圧力等の出力 ＊＊")
        SwK.WriteLine(aa$)

        velmax = 0
        For ip = 1 To Npoint
            ii = Kcomp(ip)
            aa$ = Str$(ip)
            j = Ndim * (ii - 1)
            For k = 1 To 3
                jj = Lcomp(j + k)
                b1 = Tff(jj)
                zbuf(k) = b1
                aa$ = aa$ + ",  " + Str$(zbuf(k))
                b2 = Math.Abs(b1)
                If b2 > velmax Then
                    velmax = b2
                End If
            Next k
            jj = Lcomp(j + 4)
            zbuf(4) = Tff(jj)
            aa$ = aa$ + ",  " + Str$(zbuf(4))
            If KindTherm > 0 Then
                b1 = Tft(ip)
                i1 = Int(b1)
                b2 = b1 - i1
                zbuf(5) = CInt(b2 * 100) / 100 + i1
                aa$ = aa$ + ",  " + Str$(zbuf(5))
            End If
            SwK.WriteLine(aa$)
            For k = 1 To 5
                If Math.Abs(zbuf(k)) > Math.Abs(VarMax(k)) Then
                    VarMax(k) = zbuf(k)
                    KVarMax(k) = ip
                End If
            Next k
        Next ip

    End Sub

    Private Sub ResFile3T(ByVal itime As Integer, ByRef velmax As Double)
        '非定常の結果ﾌｧｲﾙへの出力3
        'itime･･･時間ﾒｯｼｭ番号
        'velmax･･･最大速度（絶対値）
        Dim aa$
        Dim i1, ii, ip, j, jj, k As Integer
        Dim b1, b2 As Double
        Dim zbuf(5) As Single

        SwK.WriteLine("-----------------------------------------------")
        aa$ = "＜時間メッシュ番号、時間＞" + "," + Str(itime) + "," + Str(TimeNew)
        SwK.WriteLine(aa$)
        SwK.WriteLine("＊＊ 速度・圧力等の出力 ＊＊")
        aa$ = "＜節点番号、速度Ｕ、速度Ｖ、速度Ｗ、圧力"
        If KindTherm = 0 Then
            aa$ = aa$ + "＞"
        Else
            aa$ = aa$ + "、温度＞"
        End If
        SwK.WriteLine(aa$)

        velmax = 0
        For ip = 1 To Npoint
            ii = Kcomp(ip)
            aa$ = Str$(ip)
            j = Ndim * (ii - 1)
            For k = 1 To 3
                jj = Lcomp(j + k)
                b1 = Tff(jj)
                zbuf(k) = b1
                aa$ = aa$ + ",  " + Str$(zbuf(k))
                b2 = Math.Abs(b1)
                If b2 > velmax Then
                    velmax = b2
                End If
            Next k
            jj = Lcomp(j + 4)
            zbuf(4) = Tff(jj)
            aa$ = aa$ + ",  " + Str$(zbuf(4))
            If KindTherm > 0 Then
                b1 = Tft(ii)
                i1 = Int(b1)
                b2 = b1 - i1
                zbuf(5) = CInt(b2 * 100) / 100 + i1
                aa$ = aa$ + ",  " + Str$(zbuf(5))
            End If
            SwK.WriteLine(aa$)
            For k = 1 To 5
                If Math.Abs(zbuf(k)) > Math.Abs(VarMax(k)) Then
                    VarMax(k) = zbuf(k)
                    KVarMax(k) = ip
                    TimeVMax(k) = TimeNew
                End If
            Next k
        Next ip

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim aa$, ad$
        Dim abuf$(8)
        Dim i As Integer
        ad$ = "-------------------------------------------------------"
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞" + Cr$ + aa$
        aa$ = "変数項目、   最大値、         節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        abuf$(1) = "速度Ｕ"
        abuf$(2) = "速度Ｖ"
        abuf$(3) = "速度Ｗ"
        abuf$(4) = "圧力"
        abuf$(5) = "温度"
        abuf$(6) = "剪断速度"
        abuf$(7) = "粘度"
        abuf$(8) = "剪断応力"
        For i = 1 To 8
            If i <> 5 Or KindTherm > 0 Then
                aa$ = abuf$(i) + ",  "
                aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(VarMax(i)) + ",  "
                aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KVarMax(i))
                SwK.WriteLine(aa$)
                CalcRes$ = CalcRes$ + Cr$ + aa$
            End If
        Next i

    End Sub

    Private Sub ResFile4T()
        '非定常の結果ﾌｧｲﾙへの出力4
        Dim aa$, ad$
        Dim abuf$(8)
        Dim i As Integer
        ad$ = "-------------------------------------------------------"
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞" + Cr$ + aa$
        aa$ = "変数項目、   最大値、         節点番号、   時間"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        abuf$(1) = "速度Ｕ"
        abuf$(2) = "速度Ｖ"
        abuf$(3) = "速度Ｗ"
        abuf$(4) = "圧力"
        abuf$(5) = "温度"
        abuf$(6) = "剪断速度"
        abuf$(7) = "粘度"
        abuf$(8) = "剪断応力"
        For i = 1 To 8
            If i <> 5 Or KindTherm > 0 Then
                aa$ = abuf$(i) + ",  "
                aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(VarMax(i)) + ",  "
                aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KVarMax(i)) + ",  "
                aa$ = aa$ + Space$(42 - Len(aa$)) + Str$(TimeVMax(i))
                SwK.WriteLine(aa$)
                CalcRes$ = CalcRes$ + Cr$ + aa$
            End If
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'ub･･･拘束値
        Dim it, kb, kbx As Integer
        For kb = Krowpos(k) To Krowpos(k + 1) - 1
            it = Jcolnum(kb)
            If it = k Then
                Tk(kb) = 1
            ElseIf kb > 0 Then
                Call StoreIndex(it, k, kbx) '保存配列位置の算出
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(kbx) * ub
                End If
                Tk(kbx) = 0
                Tk(kb) = 0
            End If
        Next kb
        Tf(k) = ub

    End Sub

    Private Sub RestCondT(ByVal k As Integer, ByVal mh As Integer, _
    ByVal nx As Integer, ByVal ub As Double)
        '温度の拘束条件処理
        'k･･･変数番号
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        'ub･･･拘束値
        Dim it, k2, kb, kbx, m As Integer

        For it = k - NumDiagT(k) + 1 To k
            kb = IdiagT(k) + it - k
            If it = k Then
                Tk(kb) = 1
            Else
                kbx = IdiagT(k) + k - it
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(kbx) * ub
                End If
                Tk(kbx) = 0
                Tk(kb) = 0
            End If
        Next it

        If k < nx Then
            k2 = k + mh - 1
            If k2 > nx Then
                k2 = nx
            End If
            For it = k + 1 To k2
                m = it - k
                If m < NumDiagT(it) Then
                    kb = IdiagT(it) + m
                    kbx = IdiagT(it) - m
                    If ub <> 0 Then
                        Tf(it) = Tf(it) - Tk(kbx) * ub
                    End If
                    Tk(kbx) = 0
                    Tk(kb) = 0
                End If
            Next it
        End If

        Tf(k) = ub

    End Sub

    Private Sub ShearRate(ByRef bf As Double, ByVal dj As Double, _
        ByRef gd As Double)
        '剪断速度の計算
        'bf･･･ｴﾈﾙｷﾞｰ式のΦ
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        'gd･･･剪断速度
        Dim i, j, jj, k, nmax As Integer
        Dim b1, b2, b3, b4, c5 As Double
        Dim bufx(3), bufy(3), bufz(3) As Double
        Dim dubuf(3), dvbuf(3), dwbuf(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To nmax
            j = 4 * i - 3
            For k = 0 To 2
                jj = NPrefer(j + k)
                c5 = Tff(jj)
                b1 = Ds(i) * c5
                b2 = Dt(i) * c5
                b3 = Du(i) * c5
                Select Case k
                    Case 0
                        bufx(1) = bufx(1) + b1
                        bufx(2) = bufx(2) + b2
                        bufx(3) = bufx(3) + b3
                    Case 1
                        bufy(1) = bufy(1) + b1
                        bufy(2) = bufy(2) + b2
                        bufy(3) = bufy(3) + b3
                    Case 2
                        bufz(1) = bufz(1) + b1
                        bufz(2) = bufz(2) + b2
                        bufz(3) = bufz(3) + b3
                End Select
            Next k
        Next i
        For i = 1 To 3
            b1 = 0 : b2 = 0 : b3 = 0
            For j = 1 To 3
                b1 = b1 + bufx(j) * RinvJ(i, j)
                b2 = b2 + bufy(j) * RinvJ(i, j)
                b3 = b3 + bufz(j) * RinvJ(i, j)
            Next j
            dubuf(i) = b1 / dj
            dvbuf(i) = b2 / dj
            dwbuf(i) = b3 / dj
        Next i
        b1 = dubuf(2) + dvbuf(1)
        b2 = dvbuf(3) + dwbuf(2)
        b3 = dwbuf(1) + dubuf(3)
        b4 = b1 * b1 + b2 * b2 + b3 * b3
        gd = Math.Sqrt(b4)
        c5 = 2 * (dubuf(1) ^ 2 + dvbuf(2) ^ 2 + dwbuf(3) ^ 2)
        bf = b4 + c5

    End Sub

    Private Sub Solver1T(ByVal mh As Integer, ByVal nx As Integer)
        '温度のﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（LU分解）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, icount, ij, ik, j, j1, j2, k, k1, kj, kk, m, m1, m2 As Integer
        Dim b1, b2, eps As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1T 計算中   "
        If Mstat > 0 Then
            aa$ = "時間" + Str(TimeNew) + "   " + aa$
        End If
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0

        eps = 1.0E-20
        For j = 2 To mh
            m = j - 1
            If m < NumDiagT(j) Then
                ij = IdiagT(j) + m
                Tk(ij) = Tk(ij) / Tk(1)
            End If
        Next j
        For kk = 2 To nx
            j = kk
            j2 = j + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            For i = j To j2
                m = i - j
                If m < NumDiagT(i) Then
                    ij = IdiagT(i) - m
                    k1 = i - mh + 1
                    If k1 < 1 Then
                        k1 = 1
                    End If
                    b2 = 0
                    For k = k1 To j - 1
                        m1 = i - k
                        If m1 < NumDiagT(i) Then
                            ik = IdiagT(i) - m1
                            m2 = j - k
                            If m2 < NumDiagT(j) Then
                                kj = IdiagT(j) + m2
                                b2 = b2 + Tk(ik) * Tk(kj)
                            End If
                        End If
                    Next k
                    Tk(ij) = Tk(ij) - b2
                End If
            Next i

            i = kk
            b1 = Tk(IdiagT(i))
            If Math.Abs(b1) < eps Then
                aa$ = "ｿﾙﾊﾞｰ1Tでﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            j2 = i + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            For j = i + 1 To j2
                m = j - i
                If m < NumDiagT(j) Then
                    ij = IdiagT(j) + m
                    j1 = j - mh + 1
                    If j1 < 1 Then
                        j1 = 1
                    End If
                    b2 = 0
                    For k = j1 To i - 1
                        m1 = i - k
                        If m1 < NumDiagT(i) Then
                            ik = IdiagT(i) - m1
                            m2 = j - k
                            If m2 < NumDiagT(j) Then
                                kj = IdiagT(j) + m2
                                b2 = b2 + Tk(ik) * Tk(kj)
                            End If
                        End If
                    Next k
                    Tk(ij) = (Tk(ij) - b2) / b1
                End If
            Next j
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next kk

        gr.Dispose()

    End Sub

    Private Sub Solver2T(ByVal mh As Integer, ByVal nx As Integer)
        '温度のﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, ik, k, k1, k2, m As Integer
        Dim b1, eps As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2T 計算中   "
        If Mstat > 0 Then
            aa$ = "時間" + Str(TimeNew) + "   " + aa$
        End If
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        '前進処理
        eps = 1.0E-20
        Tf(1) = Tf(1) / Tk(1)
        For i = 2 To nx
            k1 = i - mh + 1
            If k1 < 1 Then
                k1 = 1
            End If
            For k = k1 To i - 1
                m = i - k
                If m < NumDiagT(i) Then
                    ik = IdiagT(i) - m
                    Tf(i) = Tf(i) - Tk(ik) * Tf(k)
                End If
            Next k
            b1 = Tk(IdiagT(i))
            If Math.Abs(b1) < eps Then
                aa$ = "ｿﾙﾊﾞｰ2Tでﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            Tf(i) = Tf(i) / b1
        Next i

        '後退処理
        For i = nx - 1 To 1 Step -1
            k2 = i + mh - 1
            If k2 > nx Then
                k2 = nx
            End If
            For k = i + 1 To k2
                m = k - i
                If m < NumDiagT(k) Then
                    ik = IdiagT(k) + m
                    Tf(i) = Tf(i) - Tk(ik) * Tf(k)
                End If
            Next k
        Next i

        gr.Dispose()

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, ii, i1, it, j, jt, kb, nmax As Integer
        Dim b1 As Double
        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nvf
            it = NPrefer(i)
            If it > 0 Then
                For j = 1 To Nvf
                    b1 = Ek(i, j)
                    If b1 <> 0 Then
                        jt = NPrefer(j)
                        If jt > 0 Then
                            Call StoreIndex(it, jt, kb) '保存配列位置の算出
                            Tk(kb) = Tk(kb) + b1
                        End If
                    End If
                Next j
            End If
        Next i
        For i = 1 To nmax
            i1 = 4 * i - 3
            For j = 1 To 4
                ii = i1 + j - 1
                it = NPrefer(ii)
                If it > 0 Then
                    Tf(it) = Tf(it) + ForceB(i, j)
                End If
            Next j
        Next i

    End Sub

    Private Sub Store2()
        '温度計算ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it, j, jt, kb, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To nmax
            it = NPrefT(i)
            For j = 1 To nmax
                jt = NPrefT(j)
                If it >= jt Then
                    kb = IdiagT(it) - (it - jt)
                Else
                    kb = IdiagT(jt) + jt - it
                End If
                Tk(kb) = Tk(kb) + Ek(i, j)
            Next j
        Next i
    End Sub

    Private Sub StoreIndex(ByVal i As Integer, ByVal j As Integer, _
    ByRef kbx As Integer)
        'FEM行列i,j要素の保存配列位置の算出
        'i･･･行番号
        'j･･･列番号
        'kbx･･･1次元保存配列のｲﾝﾃﾞｯｸｽ番号
        Dim kb As Integer
        kbx = 0
        For kb = Krowpos(i) To Krowpos(i + 1) - 1
            If Jcolnum(kb) = j Then
                kbx = kb
                Exit For
            ElseIf Jcolnum(kb) > j Then
                Exit For
            End If
        Next kb

    End Sub

    Private Sub StressCalc()
        '剪断速度・応力の計算
        Dim aa$, timn$
        Dim i, icount, ie, ig, ii, ip, j, jg, jmax, k, kg, kh, nmax, numg As Integer
        Dim b1, b2, b3, bf, dj, et, gd, s, t, temp, u As Double
        Dim etn(Npoint), she(Npoint) As Double   '各節点の粘度、剪断速度
        Dim etnG(27), sheG(27) As Double   'ｶﾞｳｽ点の粘度、剪断速度
        Dim zbuf(3) As Single
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "剪断速度・応力 計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
        End If

        icount = 0
        For ie = 1 To Nelem
            Call CalcPrep(ie)
            For i = 1 To jmax
                sheG(i) = 0
                etnG(i) = 0
            Next i

            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            numg = numg + 1
                            u = PosGaus(kg)
                            Call ShapeFunc(1, s, t, u)         '形状関数の計算
                            Call JacobElemC(ie, numg, kh, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            Call ShearRate(bf, dj, gd) '剪断速度の計算

                            et = Rmyu
                            If Kvisc > 0 Then
                                If Kvisc < 4 Then
                                    Call ShearRate(bf, dj, gd) '剪断速度の計算
                                End If
                                If KindTherm = 0 Then
                                    temp = Tempi
                                Else
                                    temp = TG(numg)
                                End If
                                Call ViscEqua(et, gd, temp)     '粘度式計算
                            End If

                            sheG(numg) = sheG(numg) + gd
                            etnG(numg) = etnG(numg) + et
                        Next kg
                    Next jg
                Next ig
            End If

            For i = 1 To nmax
                b2 = 0 : b3 = 0
                For j = 1 To jmax
                    b1 = Tr(i, j)
                    b2 = b2 + b1 * sheG(j)
                    b3 = b3 + b1 * etnG(j)
                Next j
                ii = Kcomp(NNelem(ie, i))
                she(ii) = she(ii) + b2
                etn(ii) = etn(ii) + b3
            Next i
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        SwK.WriteLine("＊＊ 剪断速度等の出力 ＊＊")
        SwK.WriteLine("＜節点番号、剪断速度、粘度、剪断応力＞")

        For ip = 1 To Npoint
            k = Kcomp(ip)
            aa$ = Str$(ip)
            zbuf(1) = Math.Abs(she(k) / Nw(k))
            zbuf(2) = Math.Abs(etn(k) / Nw(k))
            zbuf(3) = zbuf(1) * zbuf(2)
            aa$ = aa$ + ",  " + Str$(zbuf(1))
            aa$ = aa$ + ",  " + Str$(zbuf(2))
            aa$ = aa$ + ",  " + Str$(zbuf(3))
            SwK.WriteLine(aa$)
            For k = 1 To 3
                If zbuf(k) > VarMax(k + 5) Then
                    VarMax(k + 5) = zbuf(k)
                    KVarMax(k + 5) = ip
                End If
            Next k
        Next ip
        gr.Dispose()

    End Sub

    Private Sub TempAnalysis(ByRef ik As Integer, ByVal mbht As Integer)
        '温度解析
        'ik･･･繰返し回数
        'mbht･･･温度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim ie, i, icount, ig, ip, j, jg, kg, kx, mbft, nmax, numg As Integer
        Dim aat, bbt, b1, b2, b3, b4, bf, dv, dj, et, gd, rc As Double
        Dim s, t, temp, tfb, tfx, tfxx, u, ub As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        mbft = mbht + mbht - 1
        rc = Rou * Ctherm
        For i = 1 To Npoint
            Tf(i) = 0
        Next i
        For i = 1 To NumEffT
            Tk(i) = 0
        Next i

        If Nflux > 0 Then
            Call HeatFluxSet()    '熱流束の設定
        End If

        icount = 0
        For ie = 1 To Nelem
            For i = 1 To nmax
                For j = 1 To nmax
                    Ek(i, j) = 0
                Next j
            Next i
            Call CalcPrep(ie)      '要素ﾏﾄﾘｯｸｽの計算準備

            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)  '形状関数の計算
                            Call JacobElem(ie, 1, numg, dj)
                            '要素のﾔｺﾋﾞｱﾝﾏﾄﾘｯｸｽの計算

                            Call ShearRate(bf, dj, gd) '剪断速度の計算
                            et = Rmyu
                            If Kvisc > 0 Then
                                temp = TG(numg)
                                Call ViscEqua(et, gd, temp)     '粘度式計算
                            End If

                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            b3 = et * bf
                            For i = 1 To 20
                                For j = 1 To 20
                                    b2 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                    b1 = UG(numg) * Dx(j) + VG(numg) * Dy(j) + WG(numg) * Dz(j)
                                    b4 = Shape(i) * b1
                                    Ek(i, j) = Ek(i, j) + (Rlamda * b2 + rc * b4) * dv
                                Next j
                                kx = NPrefT(i)
                                Tf(kx) = Tf(kx) + Shape(i) * b3 * dv
                            Next i
                        Next kg
                    Next jg
                Next ig
            End If

            Call Store2()   '温度計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For ip = 1 To Npoint
            If NTrest(ip) > 0 Then
                ub = TempFix(ip)
                Call RestCondT(ip, mbht, Npoint, ub)    '拘束条件処理
            End If
        Next ip

        Call Solver1T(mbht, Npoint) '温度ｿﾙﾊﾞｰ1（LUL分解）

        Call Solver2T(mbht, Npoint) '温度ｿﾙﾊﾞｰ2（前進・後退処理）

        For i = 1 To Npoint
            Tft(i) = Tf(i)
        Next i
        If ik > 1 Then
            Call FluctCheckT(aat, bbt)  '温度の発散ﾁｪｯｸ
            If ik > 2 Then
                If bbt > Stempold Then
                    For i = 1 To Npoint
                        tfb = Tf(i)
                        tfx = Told(i)
                        tfxx = Toldx(i)
                        Call RelaxCalc(tfb, tfx, tfxx)  '緩和計算
                        Tf(i) = tfb
                        Tft(i) = tfb
                    Next i
                    Call FluctCheckT(aat, bbt)  '温度の発散ﾁｪｯｸ
                End If
            End If
            Stempold = bbt
        End If

    End Sub

    Private Sub TempAnalysisT(ByVal mbht As Integer)
        '非定常の温度解析
        'mbht･･･温度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim ie, i, icount, ig, ip, j, jg, kg, kx, mbft, nmax, numg As Integer
        Dim aat, bbt, b1, b2, b3, b4, bf, dv, dj, et, gd, rc As Double
        Dim s, t, temp, tfb, tfx, tfxx, u, ub As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        mbft = mbht + mbht - 1
        rc = Rou * Ctherm
        For i = 1 To Npoint
            Tf(i) = 0
        Next i
        For i = 1 To NumEffT
            Tk(i) = 0
        Next i

        If Nflux > 0 Then
            Call HeatFluxSet()    '熱流束の設定
        End If

        icount = 0
        For ie = 1 To Nelem
            For i = 1 To nmax
                For j = 1 To nmax
                    Ek(i, j) = 0
                Next j
            Next i
            Call CalcPrepT(ie)      '要素ﾏﾄﾘｯｸｽの計算準備

            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)  '形状関数の計算
                            Call JacobElem(ie, 1, numg, dj)
                            '要素のﾔｺﾋﾞｱﾝﾏﾄﾘｯｸｽの計算

                            Call ShearRate(bf, dj, gd) '剪断速度の計算
                            et = Rmyu
                            If Kvisc > 0 Then
                                temp = TG(numg)
                                Call ViscEqua(et, gd, temp)     '粘度式計算
                            End If

                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            b3 = et * bf
                            For i = 1 To 20
                                kx = NPrefT(i)
                                For j = 1 To 20
                                    b1 = rc * Shape(i) * Shape(j) * dv / Dtime
                                    b2 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                    b2 = 0.5 * Rlamda * b2 * dv
                                    b4 = UG(numg) * Dx(j) + VG(numg) * Dy(j) + WG(numg) * Dz(j)
                                    b4 = 0.5 * rc * Shape(i) * b4 * dv
                                    Ek(i, j) = Ek(i, j) + b1 + b2 + b4
                                    Tf(kx) = Tf(kx) + (b1 - b2 - b4) * TEb(j)
                                Next j
                                Tf(kx) = Tf(kx) + Shape(i) * b3 * dv
                            Next i
                        Next kg
                    Next jg
                Next ig
            End If

            Call Store2()   '温度計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For ip = 1 To Npoint
            If NTrest(ip) > 0 Then
                ub = TempFix(ip)
                Call RestCondT(ip, mbht, Npoint, ub)    '拘束条件処理
            End If
        Next ip

        Call Solver1T(mbht, Npoint) '温度ｿﾙﾊﾞｰ1（LUL分解）

        Call Solver2T(mbht, Npoint) '温度ｿﾙﾊﾞｰ2（前進・後退処理）

        For i = 1 To Npoint
            Tft(i) = Tf(i)
        Next i
        Call FluctCheckT(aat, bbt)  '温度の発散ﾁｪｯｸ
        If bbt > Stempold Then
            For i = 1 To Npoint
                tfb = Tf(i)
                tfx = Told(i)
                tfxx = Toldx(i)
                Call RelaxCalc(tfb, tfx, tfxx)  '緩和計算
                Tf(i) = tfb
                Tft(i) = tfb
            Next i
            Call FluctCheckT(aat, bbt)  '温度の発散ﾁｪｯｸ
        End If
        Stempold = bbt

    End Sub

    Private Sub TempInitSet()
        '初期温度設定
        Dim i As Integer
        For i = 1 To Npoint
            Tft(i) = Tempi
        Next i
        If KindTherm > 0 Then
            For i = 1 To Npoint
                If NTrest(i) > 0 Then
                    Tft(i) = TempFix(i)
                End If
            Next i
        End If

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub FL3DCal3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim a1$, aa$, timn$
        Dim i, icc, icheck, iconv, ii, ik, ikb, ikmax, irev, irev2, itime As Integer
        Dim kh, mb, mbf, mbft, mbh, mbht, mbx As Integer
        Dim b0, b1, df, dtime0, dtime1, dtimestd, dtimex, freemem As Single
        Dim rmesh, rmeshsum, sec, time0, time1, time2, timenext, zdvel, zvel1 As Single
        Dim dvel, velmax As Double
        Dim date0, date1, date2 As Date
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）
        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        Call GausSetStd()  'ｶﾞｳｽ点の設定

        aa$ = "節点順序の処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        ReDim Kcomp(Npoint), KRcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        Call InitialSet1()  '初期設定
        Call VolumeCalc()   '要素体積の計算

        If KindElem = 0 Then
            Call TrSet(Tr)  '節点応力計算のTr行列の設定
        End If

        Call BandWidth(mbh, mbht) 'ﾊﾞﾝﾄﾞ幅の計算
        mbf = mbh + mbh - 1
        mbft = mbht + mbht - 1

        ReDim Tf(Neff), Tff(Neff), Vold(Neff)
        ReDim Tft(Npoint), Told(Npoint), Toldx(Npoint)
        If Mstat > 0 Then
            ReDim Tffx(Neff), Tff0(Neff), Tftx(Npoint)
        Else
            ReDim Voldx(Neff)
        End If

        ReDim Krowpos(Neff + 1), KrowDpos(Neff)
        If KindTherm > 0 Then
            ReDim IdiagT(Npoint), NumDiagT(Npoint)
        End If

        ReDim PDVel(Npoint, 9)
        If Mstat = 0 Then
            ReDim PDVelX(Npoint, 9), PDVelXX(Npoint, 9)
        End If

        Call InitialSet2()  '初期設定2
        Call ElemLengthCalc()   '要素長の計算

        Call ResFile2(mbf, mbft)    '結果ﾌｧｲﾙへの出力2

        If Kreverse = 0 Then
            irev2 = 1
        Else
            irev2 = 10
        End If
        If KindFlow = 0 And KindTherm = 0 And Kconv = 0 Then
            ikmax = 1
        Else
            ikmax = NKmax
        End If
        icheck = 0
        If Mstat = 0 Then   '定常の場合
            For irev = 1 To irev2
                Call TempInitSet()      '初期温度設定
                rmeshsum = ikmax   'ﾒｯｼｭ合計
                rmesh = 0

                Dim krb As Integer
                krb = KindRelax
                Dim crb As Single
                crb = Cratio

                icc = 0
                For ik = 1 To ikmax
                    If ik = 1 Then
                        KindRelax = 0
                        Cratio = 0.01
                    Else
                        KindRelax = krb
                        Cratio = crb
                    End If

                    aa$ = "計算No." + Str(ik) + "   "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)

                    Call PDiffVelCalc(ik)    '速度偏微分の計算

                    Application.DoEvents()
                    Call MatrixCalc(iconv, ik, mbh, mbht, dvel)
                    'ﾏﾄﾘｯｸｽ計算

                    If KindRelax > 0 And ik = 1 Then
                        Call FvolumeCalc(kh, 0, velmax, zvel1)  '要素辺の流出入量の計算
                        If kh < 0 Then
                            aa$ = "流出入量が不釣り合いです！" + Cr$
                            aa$ = aa$ + "反復法では計算できません。"
                            MsgBox(aa$, 0, "計算エラー")
                            SwK.Close()
                            End
                        End If
                    End If

                    Application.DoEvents()
                    If ikmax = 1 Or (ik > 1 And iconv > 0) Then
                        icc = 1
                    Else
                        For i = 1 To Neff
                            Voldx(i) = Vold(i)
                            Vold(i) = Tff(i)
                        Next i
                        If KindTherm > 0 Then
                            For i = 1 To Npoint
                                Toldx(i) = Told(i)
                                Told(i) = Tft(i)
                            Next i
                        End If
                    End If

                    If Kreverse = 0 Then
                        '進行表示
                        If icc = 0 Then
                            rmesh = rmesh + 1
                        Else
                            ii = ikmax - ik + 1
                            rmesh = rmesh + ii
                        End If
                        ProgressBar1.Value = 100 * rmesh / rmeshsum
                        If ik > 1 Then
                            Dim timenew As Date = Now
                            sec = TimeLap(Timst, timenew)
                            b1 = rmeshsum - rmesh
                            Call ReqTime(rmesh, b1, sec)   '残りの所要時間の計算
                        End If
                    End If
                    ikb = ik
                    If icc > 0 Then
                        Exit For
                    End If
                Next ik

                If Kreverse > 0 Then
                    icheck = icheck + 1
                    If KindFlow = 0 Then
                        If icheck < 3 Then
                            rmesh = 30.0 * icheck
                            ProgressBar1.Value = rmesh
                        Else
                            rmesh = 90.0
                            ProgressBar1.Value = 90.0
                        End If
                    Else
                        rmesh = 9.0 * icheck
                        ProgressBar1.Value = rmesh
                    End If
                    Dim timen As Date = Now
                    sec = TimeLap(Timst, timen)
                    b1 = 100 - rmesh
                    Call ReqTime(rmesh, b1, sec)   '残りの所要時間の計算

                    Call FvolumeCalc(kh, 0, velmax, zvel1)  '要素辺の流出入量の計算
                    VelAve1 = -zvel1
                    If Math.Abs(VelAve1 - VelAve) < DvelMax Then
                        Exit For
                    ElseIf icheck < 10 Then
                        If KindFlow = 0 Or icheck = 1 Then
                            RatePress0 = RatePress1
                            RatePress1 = RatePress1 * VelAve / VelAve1
                        Else
                            b0 = RatePress1
                            b1 = (VelAve - VelAve0) / (VelAve1 - VelAve0)
                            RatePress1 = (1 - b1) * RatePress0 + b1 * RatePress1
                            RatePress0 = b0
                        End If
                        VelAve0 = VelAve1
                    End If
                End If
            Next irev

            Application.DoEvents()
            zdvel = dvel
            Call ResFile3(ikb, velmax, zdvel)   '計算結果の出力
            Application.DoEvents()
            Call StressCalc()                   '剪断速度・応力の計算
            Application.DoEvents()
            Call ResFile4()                     '計算結果の出力4

            Application.DoEvents()
            aa$ = "面の流出入量 計算中" + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            Call FvolumeCalc(kh, 1, velmax, zvel1)      '要素辺の流出入量の計算

        Else    '非定常の場合
            itime = 0
            df = 100 / Ntime
            rmeshsum = Ntime     'ﾒｯｼｭ合計
            TimeNew = 0
            Call InitDataSet()  '初期値設定
            Call ResFile3T(0, velmax)   '非定常の結果ﾌｧｲﾙへの出力3
            Dim rdate As Date = Now
            date1 = rdate
            time1 = 0
            date2 = date1
            time2 = 0
            itime = 1
            Dtime = DtimeInit
            dtime0 = Dtime
            dtimestd = TimeMax / Ntime
            TimeNew = Dtime
            timenext = dtimestd
            Kinit = 0

            Do
                Application.DoEvents()
                icc = 0
                aa$ = "時間" + Str(TimeNew) + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)

                Call PDiffVelCalcT()    '非定常の速度偏微分の計算

                Application.DoEvents()
                Call MatrixCalcT(mbh, mbht) 'ﾏﾄﾘｯｸｽ計算

                dtimex = Dtime
                Application.DoEvents()
                date0 = date1
                time0 = time1
                date1 = date2
                time1 = time2
                Dim rdate1 As Date = Now
                date2 = rdate1
                time2 = TimeNew
                If TimeNew >= timenext - 0.00001 Then
                    TimeNew = timenext
                    Call ResFile3T(itime, velmax)   '非定常の結果ﾌｧｲﾙへの出力3
                    Application.DoEvents()
                    Call StressCalc()               '剪断速度・応力の計算
                    Application.DoEvents()

                    aa$ = "面の流出入量 計算中" + "   "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    Call FvolumeCalc(kh, 1, velmax, zvel1)      '要素辺の流出入量の計算

                    rmesh = itime
                    b1 = time1 - time0
                    If b1 >= Dtime Then
                        sec = TimeLap(date0, date1)
                    Else
                        b1 = Dtime
                        sec = TimeLap(date1, date2)
                    End If
                    Call ReqTimeT(rmesh, rmeshsum, b1, sec)   '残りの所要時間の計算

                    '進行表示
                    Fw1 = Fw1 + df
                    ProgressBar1.Value = 100 * Fw1 / Fw2

                    itime = itime + 1
                    timenext = TimeMax * itime / Ntime
                End If
                If itime > Ntime Then
                    icheck = 1
                End If
                If icheck = 0 Then
                    If dtime0 < dtimestd Then
                        If dtime0 = Dtime Then
                            Call DvelCalc(dvel)        '最大速度変化の計算
                            If dvel <= 0.5 * DvelMax Then
                                dtime0 = 1.5 * Dtime
                            End If
                            If dtime0 > 0.5 * RateMAmax Then
                                dtime0 = 0.5 * RateMAmax
                            End If
                            If dtime0 > dtimestd - 0.00001 Then
                                dtime0 = dtimestd
                            End If
                        End If
                    End If
                    dtime1 = timenext - TimeNew
                    If dtime1 < dtime0 + 0.00001 Then
                        Dtime = dtime1
                    Else
                        Dtime = dtime0
                    End If
                    If Kinit = 0 Then
                        TimeStd = TimeNew
                        For i = 1 To Neff
                            Tff0(i) = Tff(i)
                        Next i
                    End If
                    TimeNew = TimeNew + Dtime
                    For i = 1 To Neff
                        Vold(i) = Tffx(i)
                        Tffx(i) = Tff(i)
                    Next i
                    If KindTherm > 0 Then
                        For i = 1 To Npoint
                            Tftx(i) = Tft(i)
                            Toldx(i) = Tft(i)
                            Told(i) = Tft(i)
                        Next i
                    End If
                    Svelold = 0
                    Stempold = 0
                    Kinit = 1
                End If

                aa$ = "ﾙｰﾌﾟ終了" + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
            Loop Until icheck = 1
            Application.DoEvents()
            Call ResFile4T()    '非定常の計算結果の出力4

        End If

        Application.DoEvents()
        '進行表示
        ProgressBar1.Value = 100
        Call TimCal(1, timn$)
        freemem = Int(FreeMemoryGet() / 1000.0)
        aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
        SwK.WriteLine(aa$)

        If iconv > 0 Or Mstat > 0 Then
            Label1.Text = "計算終了！"
            Label2.Text = "計算結果をファイルへ出力しました。"
            Label3.Text = aa$
            aa$ = "計算が終了しました。"
            If Mstat = 0 Then
                aa$ = aa$ + Cr$ + "繰り返し計算回数" + Str$(ikb)
            Else
                aa$ = aa$ + Cr$ + "最終前の計算時間間隔" + Str(dtimex)
                a1$ = "最終前の計算時間間隔" + "," + Str(dtimex)
                SwK.WriteLine(a1$)
            End If
            aa$ = aa$ + Cr$ + CalcRes$
        Else
            aa$ = "計算が収束しませんでしたが、適否は"
            aa$ = aa$ + Cr$ + "結果ファイルで流出入量の差異等で"
            aa$ = aa$ + Cr$ + "判断してください!"
            SwK.WriteLine(aa$)
            aa$ = aa$ + Cr$ + "計算結果をファイルへ出力しました。"
        End If
        Me.BringToFront()
        MsgBox(aa$, 0, "計算確認")

        If kh < 0 Then
            aa$ = "流出入量が不釣り合いです！"
            MsgBox(aa$, 0, "計算エラー")
            SwK.WriteLine(aa$)
        End If

        SwK.Close()

        gr.Dispose()

        Me.Close()

    End Sub
End Class
