﻿Public Class FL3DDraw1

    Private Sub FL3DDraw1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If IncVisc = 0 Then
            RadioButton1.Text = "速度ポテンシャル固定節点"
            RadioButton2.Text = "速度ポテンシャル固定面"
            RadioButton3.Text = "面垂直流の面"
            RadioButton4.Visible = False
            RadioButton4.Enabled = False
            RadioButton5.Visible = False
            RadioButton5.Enabled = False
        Else
            RadioButton1.Text = "速度・圧力固定節点"
            RadioButton2.Text = "速度・圧力固定面"
            RadioButton3.Text = "温度固定節点"
            RadioButton4.Text = "温度固定面"
            RadioButton5.Text = "熱流束"
        End If

        If KmouseDset = 0 Then
            KmouseDset = 1
        Else
            If IncVisc = 0 And KmouseDset > 3 Then
                KmouseDset = 1
            End If
        End If
        Select Case KmouseDset
            Case 1
                RadioButton1.Checked = True
            Case 2
                RadioButton2.Checked = True
            Case 3
                RadioButton3.Checked = True
            Case 4
                RadioButton4.Checked = True
            Case 5
                RadioButton5.Checked = True
        End Select

        KmouseDchange = 0

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ic, k1, k2, nb As Integer

        If RadioButton1.Checked = True Then
            KmouseDset = 1
        ElseIf RadioButton2.Checked = True Then
            KmouseDset = 2
        ElseIf RadioButton3.Checked = True Then
            KmouseDset = 3
        ElseIf RadioButton4.Checked = True Then
            KmouseDset = 4
        Else
            KmouseDset = 5
        End If

        ic = 0
        If KDrawDatMod > 0 Then
            k1 = KE1 : k2 = KE2
            Select Case KmouseDset
                Case 1
                    Call PointSearch(nb)    '対象節点の探索
                    If nb = 0 Then
                        aa$ = "節点が入っていません！"
                        MsgBox(aa$, 0, "操作エラー")
                        ic = 1
                    End If
                Case 3
                    If IncVisc = 0 Then
                        Call ElemSearch3(nb)    '対象外周面の探索
                        If nb = 0 Then
                            aa$ = "外周面が入っていません！"
                            MsgBox(aa$, 0, "操作エラー")
                            ic = 1
                        Else
                            If nb > 1 Then
                                Call SurfPileCheck(nb) '面の重なりのﾁｪｯｸ
                            End If
                        End If
                    Else
                        Call PointSearch(nb)    '対象節点の探索
                        If nb = 0 Then
                            aa$ = "節点が入っていません！"
                            MsgBox(aa$, 0, "操作エラー")
                            ic = 1
                        End If
                    End If
                Case Else
                    Call ElemSearch3(nb)    '対象外周面の探索
                    If nb = 0 Then
                        aa$ = "外周面が入っていません！"
                        MsgBox(aa$, 0, "操作エラー")
                        ic = 1
                    Else
                        If nb > 1 Then
                            Call SurfPileCheck(nb) '面の重なりのﾁｪｯｸ
                        End If
                    End If
            End Select
        End If

        If ic = 0 Then
            Dim frm As Form = New FL3DDraw2()    'ﾃﾞｰﾀ入力画面
            frm.Show()
        End If

        Me.Close()

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

End Class